#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10;
int sum[maxn], n = 10000;

void preCompute(){
    for(int i = 1;i <= n;i++){
        int del = 1;
        while(del * del < i){
            if(i % del == 0){
                sum[i] += del;
                sum[i] += (i / del);
            }
            del++;
        }
        if(del * del == i)
            sum[i] += del;
        sum[i] -= i;
    }
}

vector<int> tree[4 * maxn];

void make_tree(int i, int l, int r){
    if(l == r){
        tree[i] = {sum[l]};
        return;
    }
    int mid = (l + r) / 2;
    make_tree(2 * i, l, mid);
    make_tree(2 * i + 1, mid + 1, r);
    int idx1 = 0, idx2 = 0, sz1 = tree[2 * i].size(), sz2 = tree[2 * i + 1].size();
    int sz = max(sz1, sz2);
    while(idx1 < sz1 || idx2 < sz2){
        if(idx1 == sz1){
            tree[i].push_back(tree[2 * i + 1][idx2++]);
            continue;
        }
        if(idx2 == sz2){
            tree[i].push_back(tree[2 * i][idx1++]);
            continue;
        }
        if(tree[2 * i][idx1] < tree[2 * i + 1][idx2]){
            tree[i].push_back(tree[2 * i][idx1++]);
        }
        else{
            tree[i].push_back(tree[2 * i + 1][idx2++]);
        }
    }
}

int bin_search(vector<int> v, int num){
    int l = 0, r = v.size() - 1, ans = -1;
    while(l <= r){
        int mid = (l + r) / 2;
        if(v[mid] > num) r = mid - 1, ans = mid;
        else l = mid + 1;
    }/**
    cout << endl;
    cout << l << endl;
    for(int x : v){
        cout << x << " ";
    }
    cout << endl;*/
    ans = l;
    ans = v.size() - ans;
    return ans;
}

int query(int i, int l, int r, int ql, int qr, int v){
    if(l == ql && r == qr){
        int ans = bin_search(tree[i], v);
        return ans;
    }
    int mid = (l + r) / 2;
    if(qr <= mid) return query(2 * i, l, mid, ql, qr, v);
    if(ql > mid) return query(2 * i + 1, mid + 1, r, ql, qr, v);
    return query(2 * i, l, mid, ql, mid, v) + query(2 * i + 1, mid + 1, r, mid + 1, qr, v);
}

void solve(){
    int l, r, v;
    cin >> l >> r >> v;
    cout << query(1, 1, n, l, r, v) << '\n';
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    preCompute();
    make_tree(1, 1, n);
    while(t--){
        solve();
    }
    return 0;
}
