#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 10, n = 1e5;
int sum[maxn], par[maxn][11], p[maxn];
int tree[4 * maxn];

void preCompute(){
    for(int i = 1;i <= n;i++){
        int del = 1;
        while(del * del < i){
            if(i % del == 0){
                sum[i] += del;
                sum[i] += (i / del);
            }
            del++;
        }

        if(del * del == i)
            sum[i] += del;
        sum[i] -= i;
        p[i] += p[i - 1];
        if(sum[i] > 10)
            p[i]++;
    }
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= 10;j++){
            par[i][j] = par[i - 1][j];
        }
        if(sum[i] <= 10)
            par[i][sum[i]]++;
    }
}

void make_tree(int i, int l, int r){
    if(l == r){
        tree[i]  = sum[l] - 1;
        return;
    }
    int mid = (l + r) / 2;
    make_tree(2 * i, l, mid);
    make_tree(2 * i + 1, mid + 1, r);
    tree[i] = min(tree[2 * i], tree[2 * i + 1]);
}

int answer(int i, int l, int r, int v){
    if(l == r){
        if(tree[i] >= v) return 1;
        return 0;
    }
    int mid = (l + r) / 2;
    if(tree[i] >= v)
        return r - l + 1;
    else if(tree[2 * i] >= v)
        return answer(2 * i + 1, mid + 1, r, v) + mid - l + 1;
    else if(tree[2 * i + 1] >= v)
        return answer(2 * i, l, mid, v) + r - mid;
    else answer(2 * i + 1, mid + 1, r, v) + answer(2 * i, l, mid, v);
}

int query(int i, int l, int r, int ql, int qr, int v){
    if(l == ql && r == qr){
        return answer(i, l, r, v);
    }
    int mid = (l + r) / 2;
    if(qr <= mid) return query(2 * i, l, mid, ql, qr, v);
    if(ql > mid) return query(2 * i + 1, mid + 1, r, ql, qr, v);
    return query(2 * i, l, mid, ql, mid, v) + query(2 * i + 1, mid + 1, r, mid + 1, qr, v);
}
void solve(){
    int l, r, v;
    cin >> l >> r >> v;
    cout << query(1, 1, n, l, r, v) << '\n';
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    preCompute();
    make_tree(1, 1, n);
    while(t--){
        solve();
    }
    return 0;
}
