#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e5 + 50, MAXVAL = 310000;
int sum[MAXN], v[MAXN], ans[MAXN];
pair <int, int> l[MAXN], r[MAXN];

int sumOfDivisors(int k)
{
    int ans = 1, i;
    for (i = 2; i*i < k; i++)
    {
        if (k % i == 0)
            ans = ans + (i + k/i);
    }

    if (i*i == k && k % i == 0)
        ans += i;

    return ans;
}

struct SegmentTree
{
    int n = MAXVAL;
    int tree[4*MAXVAL];

    SegmentTree(){}

    void Build()
    {
        buildInternal(1, 0, n);
    }
    void Update(int q)
    {
        updateInternal(1, 0, n-1, q);
    }

    int Query(int ql, int qr)
    {
        return queryInternal(1, 0, n-1, ql, qr);
    }

    void Recalculate(int node)
    {
        tree[node] = tree[node*2] + tree[node*2 + 1];
    }

    void buildInternal(int node, int l, int r)
    {
        if (l == r)
        {
            tree[node] = 0;
            return;
        }

        buildInternal(node*2, l, (l+r)/2);
        buildInternal(node*2+1, (l+r)/2 + 1, r);

        Recalculate(node);
    }

    void updateInternal(int node, int l, int r, int q)
    {
        if (l > q || r < q)
            return;

        if (l == r)
        {
            tree[node]++;
            return;
        }

        updateInternal(node*2, l, (l+r)/2, q);
        updateInternal(node*2+1, (l+r)/2 + 1, r, q);

        Recalculate(node);
    }

    int queryInternal(int node, int l, int r, int ql, int qr)
    {
        if (l > qr || r < ql)
            return 0;

        if (ql <= l && r <= qr)
            return tree[node];

        return queryInternal(node*2, l, (l+r)/2, ql, qr) + queryInternal(node*2+1, (l+r)/2 + 1, r, ql, qr);
    }
};
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    sum[1] = 0;
    for (int i = 2; i <= 100003; i++)
        sum[i] = sumOfDivisors(i);

    int q;
    cin >> q;

    for (int i = 0; i < q; i++)
    {
        cin >> l[i].first >> r[i].first >> v[i];
        l[i].second = r[i].second = i;
    }

    sort (l, l+q);
    sort (r, r+q);

    SegmentTree *treeR = new SegmentTree();
    treeR->Build();

    int prevEnd = 0;
    for (int i = 0; i < q; i++)
    {
        for (int j = prevEnd+1; j <= r[i].first; j++)
            treeR->Update(sum[j]);

        prevEnd = r[i].first;
        ans[r[i].second] += treeR->Query(v[r[i].second]+1, MAXVAL);
    }

    SegmentTree *treeL = new SegmentTree();
    treeL->Build();

    prevEnd = 1;
    for (int i = 0; i < q; i++)
    {
        for (int j = prevEnd; j < l[i].first; j++)
            treeL->Update(sum[j]);

        prevEnd = l[i].first;
        cout << l[i].second << " " <<  treeL->Query(1, v[l[i].second]-1) << endl;
    }

    for (int i = 0; i < q; i++)
        cout << ans[i] << endl;
        return 0;
}
