#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

struct Join {
	ll val;
	ll v;
	ll l;
	ll r;
	ll ind;
	bool is_point;
	Join(ll _val, ll _i) {
		val = _val;
		is_point = true;
		ind = _i;
		v = l = r = 0;
	}
	Join(ll _l, ll _r, ll _v, ll _i) {
		l = _l;
		r = _r;
		v = _v;
		is_point = false;
		ind = _i;
		val = 0;
	}
	bool operator<(const Join& other)const {
		if (is_point && other.is_point) {
			return val > other.val;
		}
		else if (!is_point && other.is_point) {
			if (v == other.val) {
				return true;
			}
			return v > other.val;
		}
		else if(is_point && !other.is_point) {
			if (val == other.v) {
				return false;
			}
			return val > other.v;
		}
		else {
			return v > other.v;
		}
	}
};

ll ttt;
const ll MOD = 1e9 + 7;
const ll N = 1e5 + 7;
ll n, m, k;
int a[N];
bool is_comp[N];
vector<int>primes;
vector<Join>d;
int ans[N];
int bit[4 * N];

void update(int ind) {
	while (ind < n) {
		bit[ind]++;
		ind += ind & (-ind);
	}
}

int query(int ind) {
	int res = 0;
	while (ind) {
		res += bit[ind];
		ind -= ind & (-ind);
	}
	return res;
}

void eratosthenes(int vl) {
	for (ll i = 2; i <= vl; i++) {
		if (!is_comp[i]) {
			primes.push_back(i);
			for (ll j = i * i; j < N; j += i) {
				is_comp[j] = true;
			}
		}
	}
}

ll sum_of_divisors(ll x) {
	ll tmp = x;
	ll ans = 1;
	for (int i : primes) {
		ll cur = 1;
		ll exp = 0;
		while (x % i == 0) {
			x /= i;
			exp++;
			cur += pow(i, exp);
		}
		ans *= cur;
		if (x == 1)return ans - tmp;
		if (!is_comp[x]) {
			ans *= (x + 1);
			return ans - tmp;
		}
	}
	return ans;
}

void precalc(int vl) {
	eratosthenes(vl);
	for (int i = 1; i <= vl; i++) {
		a[i] = sum_of_divisors(i);
		//cout << a[i] << " ";
		d.push_back(Join(a[i], i));
	}
}

int main() {
	cin >> ttt;
	n = N;
	m = ttt;
	int cur_ind = 0;
	int maxr = 0;
	while (ttt--) {
		int l, r, v;
		cin >> l >> r >> v;
		maxr = max(maxr, r);
		d.push_back(Join(l, r, v, cur_ind));
		cur_ind++;
	}
	precalc(maxr + 1);
	sort(d.begin(), d.end());
	for (int i = 0; i < d.size(); i++) {
		if (d[i].is_point) {
			//if(d[i].ind<=50)cout << d[i].ind << ": " << d[i].val << endl;
			update(d[i].ind);
		}
		else {
			//cout << d[i].ind << endl;
			ans[d[i].ind] = query(d[i].r) - query(d[i].l - 1);
		}
	}
	for (int i = 0; i < m; i++) {
		cout << ans[i] << endl;
	}
	cout << endl;
}