#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>
#include <list>
using namespace std;
const int N = 1e5 + 1;
int sum[N], cnt = 0;
vector<int> tree[4 * N];
void build_tree(int v, int tl, int tr) {
	if (tl == tr)
		tree[v].push_back(sum[tl]);
	else {
		int tm = (tl + tr) / 2;
		build_tree(2 * v, tl, tm);
		build_tree(2 * v + 1, tm + 1, tr);
		int ind1 = 0, ind2 = 0, n = (int)tree[2 * v].size(), m = (int)tree[2 * v + 1].size();
		while (ind1 < n || ind2 < m) {
			if (ind1 == n) tree[v].push_back(tree[2 * v + 1][ind2++]);
			else if (ind2 == m) tree[v].push_back(tree[2 * v][ind1++]);
			else {
				if (tree[2 * v][ind1] < tree[2 * v + 1][ind2]) tree[v].push_back(tree[2 * v][ind1++]);
				else tree[v].push_back(tree[2 * v + 1][ind2++]);
			}
		}
	}
}
int count(int v, int tl, int tr, int l, int r, int k) {
	if (tl > r || tr < l) return 0;
	if (tl >= l && tr <= r) {
		int ll = 0, rr = (int)tree[v].size() - 1, answ = (int)tree[v].size();
		while (ll <= rr) {
			int mid = (ll + rr) / 2;
			if (tree[v][mid] > k) {
				answ = mid;
				rr = mid - 1;
			}
			else ll = mid + 1;
		}
		return (int)tree[v].size() - answ;
	}
	int tm = (tl + tr) / 2;
	return count(2 * v, tl, tm, l, r, k) +
		count(2 * v + 1, tm + 1, tr, l, r, k);
}
void precalc() {
	sum[1] = 1;
	for (int i = 2; i < N; i++) {
		int j = 2;
		while (j * j <= i) {
			cnt++;
			if (i % j == 0) {
				int v = i, sm = 1, k = 1;
				while (v % j == 0) {
					v /= j;
					k *= j;
					sm += k;
				}
				if (v != 1) sum[i] = sum[v] * sm;
				else sum[i] = sm;
				break;
			}
			j++;
		}
		if (sum[i] == 0) sum[i] = i + 1;
	}
	for (int i = 1; i < N; i++) {
		sum[i] -= i;
	}
}
int main()
{
	precalc();
	build_tree(1, 1, N - 1);
	int q;
	scanf("%d", &q);
	while (q--) {
		int l, r, v;
		scanf("%d%d%d", &l, &r, &v);
                cout << count(1, 1, N - 1, l, r, v) << "\n";
	}
}