#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>
#include <list>
using namespace std;
const int N = 1e5 + 1;
int sum[N], cnt = 0;
vector<int> tree[4 * N];
void build_tree(int v, int tl, int tr) {
    if (tl == tr)
        tree[v].push_back(sum[tl]);
    else {
        int tm = (tl + tr) / 2;
        build_tree(2 * v, tl, tm);
        build_tree(2 * v + 1, tm + 1, tr);
        tree[v].resize((int)tree[2 * v].size() + (int)tree[2 * v + 1].size());
        merge(tree[2 * v].begin(), tree[2 * v].end(), tree[2 * v + 1].begin(), tree[2 * v + 1].end(), tree[v].begin());
    }
}
int count(int v, int tl, int tr, int l, int r, int k) {
    if (tl > r || tr < l) return 0;
    if (tl >= l && tr <= r) return tree[v].end() - upper_bound(tree[v].begin(), tree[v].end(), k);
    int tm = (tl + tr) / 2;
    return count(2 * v, tl, tm, l, r, k) +
        count(2 * v + 1, tm + 1, tr, l, r, k);
}
void precalc() {
    sum[1] = 1;
    for (int i = 2; i < N; i++) {
        int j = 2;
        while (j * j <= i) {
            cnt++;
            if (i % j == 0) {
                int v = i, sm = 1, k = 1;
                while (v % j == 0) {
                    v /= j;
                    k *= j;
                    sm += k;
                }
                if (v != 1) sum[i] = sum[v] * sm;
                else sum[i] = sm;
                break;
            }
            j++;
        }
        if (sum[i] == 0) sum[i] = i + 1;
    }
    for (int i = 1; i < N; i++) {
        sum[i] -= i;
    }
}
int main()
{
    precalc();
    build_tree(1, 1, N - 1);
    int q;
    scanf("%d", &q);
    while (q--) {
        int l, r, v;
        scanf("%d%d%d", &l, &r, &v);
        printf("%d\n", count(1, 1, N - 1, l, r, v));
    }
}