#include <iostream>
#include <queue>
#include <vector>
#include <algorithm>
#include <list>
using namespace std;
const int N = 1e5 + 1;
int sum[N];
vector<int> tree[262164];
void build_tree(int v, int tl, int tr) {
    if (tl == tr) {
        if (sum[tl] < N) tree[v].push_back(sum[tl]);
    }
    else {
        int tm = (tl + tr) / 2;
        build_tree(2 * v, tl, tm);
        build_tree(2 * v + 1, tm + 1, tr);
        int ind1 = 0, ind2 = 0, n = (int)tree[2 * v].size(), m = (int)tree[2 * v + 1].size();
        while (ind1 < n || ind2 < m) {
            if (ind1 == n || (ind2 < m && tree[2 * v][ind1] > tree[2 * v + 1][ind2])) {
                tree[v].push_back(tree[2 * v + 1][ind2++]);
                ind2++;
            }
            else {
                tree[v].push_back(tree[2 * v][ind1]);
                ind1++;
            }
        }
    }
}
int count(int v, int tl, int tr, int l, int r, int k) {
    if (tl > r || tr < l) return 0;
    if (tl >= l && tr <= r) return tree[v].end() - upper_bound(tree[v].begin(), tree[v].end(), k);
    int tm = (tl + tr) / 2;
    int vl = count(2 * v, tl, tm, l, r, k);
    int vr = count(2 * v + 1, tm + 1, tr, l, r, k);
    return vl + vr;
}
void precalc() {
    sum[1] = 1;
    for (int i = 2; i < N; i++) {
        int j = 2;
        while (j * j <= i) {
           int v = i, sm = 1, k = 1;
           while (v % j == 0) {
               v /= j;
               k *= j;
               sm += k;
           }
           if (v != 1 && k != 1) sum[i] = sum[v] * sm;
           else sum[i] = sm;
        }
        if (sum[i] == 0) sum[i] = i + 1;
    }
    for (int i = 1; i < N; i++) {
        sum[i] -= i;
    }
}
int main()
{
    precalc();
    build_tree(1, 1, N - 1);
    int q;
    scanf("%d", &q);
    while (q--) {
        int l, r, v;
        scanf("%d%d%d", &l, &r, &v);
        printf("%d\n", count(1, 1, N - 1, l, r, v));
    }
}