﻿#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using LL = long long;
template<typename T>
using V = vector<T>;

const int N = 131072; // 2^17
V<int> sorted_d_sum[4 * N];
LL divisors_sum[N];

LL binpow(LL a, int n)
{
	LL ans = 1;
	while (n) {
		if (n & 1)
			ans *= a;
		a *= a;
		n >>= 1;
	}
	return ans;
}

void merge_sort(int lx, int rx, int x)
{
	if (lx == rx) {
		sorted_d_sum[x].push_back(divisors_sum[lx] - (lx + 1));
		return;
	}
	merge_sort(lx, (lx + rx) / 2, 2 * x + 1);
	merge_sort((lx + rx) / 2 + 1, rx, 2 * x + 2);
	int i, j;
	for (i = 0, j = 0; i < (rx - lx + 1) / 2 && j < (rx - lx + 1) / 2;)
		if (sorted_d_sum[2 * x + 1][i] < sorted_d_sum[2 * x + 2][j])
			sorted_d_sum[x].push_back(sorted_d_sum[2 * x + 1][i++]);
		else
			sorted_d_sum[x].push_back(sorted_d_sum[2 * x + 2][j++]);
	while (i < (rx - lx + 1) / 2)
		sorted_d_sum[x].push_back(sorted_d_sum[2 * x + 1][i++]);
	while (j < (rx - lx + 1) / 2)
		sorted_d_sum[x].push_back(sorted_d_sum[2 * x + 2][j++]);
}

void PreCalc()
{
	int i, j, k, cnt;
	divisors_sum[0] = 1;
	for (i = 2; i <= N; ++i) {
		for (j = 2; j * j <= i; ++j) {
			k = i;
			cnt = 0;
			while (k % j == 0) {
				++cnt;
				k /= j;
			}
			if (cnt) {
				divisors_sum[i - 1] = divisors_sum[k - 1] * (binpow(j, cnt + 1) - 1) / (j - 1);
				break;
			}
		}
		if (!divisors_sum[i - 1])
			divisors_sum[i - 1] = i + 1;
	}
	merge_sort(0, N - 1, 0);
}

int count_rich(V<int>& vec, int v)
{
	return vec.size() - (upper_bound(vec.begin(), vec.end(), v) - vec.begin());
}

int get(int lx, int rx, int x, int l, int r, int v)
{
	if (lx > r || rx < l)
		return 0;
	if (lx >= l && rx <= r)
		return count_rich(sorted_d_sum[x], v);
	return get(lx, (lx + rx) / 2, 2 * x + 1, l, r, v) + get((lx + rx) / 2 + 1, rx, 2 * x + 2, l, r, v);
}

int main()
{
	PreCalc();
	int q, l, r, v;
	cin >> q;
	while (q--) {
		cin >> l >> r >> v;
		cout << get(0, N - 1, 0, l - 1, r - 1, v) << '\n';
	}
	return 0;
}