#include <bits/stdc++.h>

#define lg int

using namespace std;

struct segtree{
	vector<vector<lg>> seg;
	lg n;
	segtree(lg sz)
	{
		lg x = __lg(sz);
		if((1ll << x) != sz)	x++;
		n = (1ll << x);
		seg.resize(2*n);
	}
	void build()
	{
		for(int i = 1; i <= n; i++)	seg[i-1+n].push_back(0);
		for(int i = 1; i <= n; i++)
		{
			for(int j = i*2; j <= n; j += i)
			{
				seg[j-1+n][0] += i;
			}
		}
		for(int i = n-1; i > 0; i--)
		{
			lg l = 0, r = 0;
			while(l < seg[i*2].size() && r < seg[i*2+1].size())
			{
				if(seg[i*2][l] < seg[i*2+1][r])	seg[i].push_back(seg[i*2][l++]);
				else	seg[i].push_back(seg[i*2+1][r++]);
			}
			while(l < seg[i*2].size())
			{
				seg[i].push_back(seg[i*2][l++]);
			}
			while(r < seg[i*2+1].size())
			{
				seg[i].push_back(seg[i*2+1][r++]);
			}
		}
	}
	lg get(lg node, lg low_range, lg high_range, lg low_query, lg high_query, lg val)
	{
		if(low_range > high_query || low_query > high_range)	return 0;
		if(low_range >= low_query && high_query >= high_range)
		{
			lg l = 0, r = seg[node].size()-1, ans = seg[node].size();
			while(l <= r)
			{
				lg mid = (l+r)/2;
				if(seg[node][mid] > val)	
				{
					r = mid-1;
					ans = mid;
				}
				else	l = mid+1;
			}
			return seg[node].size()-ans;
		}
		lg mid = (low_range+high_range)/2;
		return get(node*2, low_range, mid, low_query, high_query, val)+get(node*2+1, mid+1, high_range, low_query, high_query, val);
	}
};

int main()
{
	segtree s(1e5);	
	s.build();
	lg q;
	cin >> q;
	while(q--)
	{
		lg l, r, v;
		cin >> l >> r >> v;
		cout << s.get(1, 1, s.n, l, r, v) << '\n';
	}
}