#include <bits/stdc++.h>


using namespace std;

vector<int> seg[262144];

struct segtree{
	int n = 1;
	segtree(int sz)
	{
		while(n < sz)	n = (n << 1);
	}
	void build()
	{
		for(int i = 1; i <= n; i++)	seg[i-1+n].push_back(0);
		for(int i = 1; i <= n; i++)
		{
			for(int j = i*2; j <= n; j += i)
			{
				seg[j-1+n][0] += i;
			}
		}
		for(int i = n-1; i > 0; i--)
		{
			int l = 0, r = 0;
			while(l < seg[i*2].size() && r < seg[i*2+1].size())
			{
				if(seg[i*2][l] < seg[i*2+1][r])	seg[i].push_back(seg[i*2][l++]);
				else	seg[i].push_back(seg[i*2+1][r++]);
			}
			while(l < seg[i*2].size())
			{
				seg[i].push_back(seg[i*2][l++]);
			}
			while(r < seg[i*2+1].size())
			{
				seg[i].push_back(seg[i*2+1][r++]);
			}
		}
	}
	int get(int node, int low_range, int high_range, int low_query, int high_query, int val)
	{
		if(low_range > high_query || low_query > high_range)	return 0;
		if(low_range >= low_query && high_query >= high_range)
		{
			int l = 0, r = seg[node].size()-1, ans = seg[node].size();
			while(l <= r)
			{
				int mid = (l+r)/2;
				if(seg[node][mid] > val)	
				{
					r = mid-1;
					ans = mid;
				}
				else	l = mid+1;
			}
			return seg[node].size()-ans;
		}
		int mid = (low_range+high_range)/2;
		return get(node*2, low_range, mid, low_query, high_query, val)+get(node*2+1, mid+1, high_range, low_query, high_query, val);
	}
};

int main()
{
	ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);
	segtree s(1e5);	
	s.build();
	int q;
	cin >> q;
	while(q--)
	{
		int l, r, v;
		cin >> l >> r >> v;
		cout << s.get(1, 1, s.n, l, r, v) << '\n';
	}
}