#include <iostream>
#include <vector>
#pragma GCC optimize("O3", "unroll-loops")

using namespace std;

vector<int> seg[262144];
int miss[int(1e5+1)];
int n = 131072, low_query, high_query, val;

void build()
{
    for(int i = 2; i <= 1e5; i++)
    {
        for(int j = (i << 1); j <= 1e5; j += i)
        {
            if(seg[j-1+n].empty())	seg[j-1+n].push_back(i);
            else	seg[j-1+n][0] += i;
        }
    }
    for(int i = 0; i < 1e5; i++)	miss[i+1] += (seg[i+n].empty())+miss[i];
    int l, r;
    for(int i = n-1; i > 0; i--)
    {
        l = r = 0;
        while(l < seg[(i << 1)].size() && r < seg[(i << 1)+1].size())
        {
            if(seg[(i << 1)][l] < seg[(i << 1)+1][r])	seg[i].push_back(seg[(i << 1)][l++]);
            else	seg[i].push_back(seg[(i << 1)+1][r++]);
        }
        while(l < seg[(i << 1)].size())
        {
            seg[i].push_back(seg[(i << 1)][l++]);
        }
        while(r < seg[(i << 1)+1].size())
        {
            seg[i].push_back(seg[(i << 1)+1][r++]);
        }
    }
    return;
}

int get(int node, int low_range, int high_range)
{
    if(seg[node].empty())	return 0;
    if(val > seg[node].back())	return 0;
    if(val < seg[node].front())	return max(0, min(high_query, high_range)-max(low_range, low_query)+1-(miss[min(high_query, high_range)]-miss[max(low_range, low_query)-1]));
    if(low_range > high_query || low_query > high_range)	return 0;
    if(low_range >= low_query && high_query >= high_range)
    {
        if(val > seg[node].back())	return 0;
        if(val < seg[node].front())	return seg[node].size();
        int l = 0, r = seg[node].size()-1, ans = seg[node].size();
        while(l <= r)
        {
            int mid = ((l+r) >> 1);
            if(seg[node][mid] > val)	
            {
                r = mid-1;
                ans = mid;
            }
            else	l = mid+1;
        }
        return seg[node].size()-ans;
    }
    int mid = ((low_range+high_range) >> 1);
    return get((node << 1), low_range, mid)+get((node << 1)+1, mid+1, high_range);
}

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(NULL);cout.tie(NULL);	
    build();
    int q;
    cin >> q;
    while(q--)
    {
        cin >> low_query >> high_query >> val;
        val--;
        cout << get(1, 1, n) << '\n';
    }
}