#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#define int int_fast64_t
#define segl i * 2 + 1, l, (r + l) / 2
#define segr i * 2 + 2, (r + l) / 2, r
#define all(a) (a).begin(), (a).end()

using namespace std;

struct Node {
	vector<int> val;
	Node() {}
};

vector<int> sigma(1e5 + 5, 0);
vector<Node> tree(4 * (1e5 + 5));

void build(int i, int l, int r) {
	tree[i].val = vector<int>(r - l);
	if (l + 1 == r) {
		tree[i].val[0] = sigma[l];
		return;
	}
	build(segl);
	build(segr);
	merge(all(tree[i * 2 + 1].val), all(tree[i * 2 + 2].val), tree[i].val.begin());
}

int get(int i, int l, int r, int ql, int qr, int x) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree[i].val.end() - upper_bound(all(tree[i].val), x);
	}
	return (get(segl, ql, qr, x) + get(segr, ql, qr, x));
}

void solve() {
	
	for (int i = 1; i < sigma.size(); ++i) {
		for (int j = i * 2; j < sigma.size(); j += i) {
			sigma[j] += i;
		}
	}
	build(0, 0, sigma.size());
	int t;
	cin >> t;
	while (t--) {
		int l, r, v;
		cin >> l >> r >> v;
		cout << get(0, 0, sigma.size(), l, ++r, v) << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
}