#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#define segl i * 2 + 1, l, (r + l) / 2
#define segr i * 2 + 2, (r + l) / 2, r
#define all(a) (a).begin(), (a).end()

using namespace std;

struct Node {
	vector<int> val;
	int sz = 0;
	Node() {}
	Node(int _sz) {
		sz = _sz;
		val.resize(_sz);
	}
	int size() {
		return sz;
	}
};

int sigma[100000];
Node tree[400000];

void build(int i, int l, int r) {
	tree[i] = Node(r - l);
	if (l + 1 == r) {
		tree[i].val[0] = sigma[l];
		return;
	}
	int mg = (r + l) / 2;
	build(segl);
	build(segr);
	int cur = 0;
	int _l = 0, _r = 0;
	while (_l != tree[i * 2 + 1].size() || _r != tree[i * 2 + 2].size()) {
		if (_l == tree[i * 2 + 1].size()) {
			tree[i].val[cur++] = tree[i * 2 + 2].val[_r++];
			continue;
		}
		if (_r == tree[i * 2 + 2].size()) {
			tree[i].val[cur++] = tree[i * 2 + 1].val[_l++];
			continue;
		}
		if (tree[i * 2 + 1].val[_l] < tree[i * 2 + 2].val[_r]) {
			tree[i].val[cur++] = tree[i * 2 + 1].val[_l++];
		}
		else {
			tree[i].val[cur++] = tree[i * 2 + 2].val[_r++];
		}
	};
}

int _bin(vector<int>& a, int sz, int x) {
	int l = -1, r = sz;
	while (r - l > 1) {
		int mg = (r + l) / 2;
		if (a[mg] > x)
			r = mg;
		else
			l = mg;
	}
	return r;
}

int get(int i, int l, int r, int ql, int qr, int x) {
	if (qr <= l || r <= ql) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree[i].size() - _bin(tree[i].val, tree[i].size(), x);
	}
	return (get(segl, ql, qr, x) + get(segr, ql, qr, x));
}

void solve() {
	
	for (int i = 1; i < 100000; ++i) {
		for (int j = i * 2; j < 100000; j += i) {
			sigma[j] += i;
		}
	}
	build(0, 0, 100000);
	int t;
	cin >> t;
	while (t--) {
		int l, r, v;
		cin >> l >> r >> v;
		cout << get(0, 0, 100000, l, ++r, v) << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
}