#include "bits/stdc++.h"
using namespace std;

const int N = 100001;
const int sz = 131072;
long long s[N + 1];

vector<vector<long long>> tree(2 * sz,vector<long long> ());

constexpr void calc_s() {
    for (long long i = 1; i <= N; i++) {
        for (long long j = 2 * i; j <= N; j += i) {
            s[j] += i;
        }
    }
}

void build(int x, int lx, int rx) {
    if (rx - lx == 1) {
        if (lx < size(s)) {
            tree[x].push_back(s[lx]);
        }
    } else {
        int m = (lx + rx) / 2;
        build(2 * x + 1, lx, m);
        build(2 * x + 2, m, rx);
        tree[x].resize(rx - lx);
        merge(tree[2 * x + 1].begin(),tree[2 * x + 1].end(),tree[2 * x + 2].begin(),tree[2 * x + 2].end(),tree[x].begin());
    }
}

int get(int l, int r, int k, int x, int lx, int rx) {
    if (r <= lx || rx <= l) {
        return 0;
    } else if (l <= lx && rx <= r) {
        int res = (int)(tree[x].end() - upper_bound(tree[x].begin(), tree[x].end(), k));
        return res;
    } else {
        int m = (lx + rx) / 2;
        int s1 = get(l, r, k, 2 * x + 1, lx, m);
        int s2 = get(l, r, k, 2 * x + 2, m, rx);
        return s1 + s2;
    }
}

int get(int l, int r, int k) {
    return get(l, r, k, 0, 0, sz);
}

void init() {
    tree.assign(2 * sz, vector<long long> ());
    build(0, 0, sz);
}

void solve() {
    calc_s();

    init();

    int q;
    cin >> q;
    while (q--) {
        int l, r, v;
        cin >> l >> r >> v;

        cout << get(l, r + 1, v) << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}