﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include "coins.h"
#include <random>
using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
mt19937 rng(0);
const ll INF = 1e14;
ll n;
vector<ll> c, t, h;
vector<vector<ll>> g;
struct Segtree {
    struct Node {
        ll x;
        Node() : x(INF) {}
        Node(ll x) : x(x) {}
        Node operator+(const Node& other) const {
            Node res = Node(min(x, other.x));
            return res;
        }
    };
    vector<Node> t;
    ll sz;
    Segtree() {}
    Segtree(vector<ll>& v) : sz(1) {
        ll n = v.size();
        while (sz < n) sz *= 2;
        t.resize(sz * 2, Node());
        for (ll i = 0; i < n; i++)
            t[sz + i] = Node(v[i]);
        for (ll i = sz - 1; i >= 1; i--)
            t[i] = t[i * 2] + t[i * 2 + 1];
    }
    void change(ll i, ll d) {
        t[sz + i] = Node(d);
        ll v = (sz + i) / 2;
        while (v > 0) {
            t[v] = t[v * 2] + t[v * 2 + 1];
            v /= 2;
        }
    }
    Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
        if (r == -1) r = sz;
        if (lx <= l && r <= rx) return t[v];
        if (lx >= r || l >= rx) return Node();
        ll mid = (l + r) / 2;
        return get(lx, rx, v * 2, l, mid) + get(lx, rx, v * 2 + 1, mid, r);
    }
};
Segtree cmn;
void solve1() {
    vector<ll> v(n);
    ll u = 0;
    forr(i, n) if (g[i].size() == 1) u = i;
    v[0] = u, v[1] = g[u][0];
    for (ll i = 2; i < n; i++) {
        if (g[v[i - 1]][0] != v[i - 2])
            v[i] = g[v[i - 1]][0];
        else
            v[i] = g[v[i - 1]][1];
    }
    vector<ll> dp(n, INF);
    Segtree seg = Segtree(dp);
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j <= i; j++) {
            for (ll k = i - j; k < t[v[j]]; k++) {
                ll cc = c[k];
                if (j - k - 1 >= 0) dp[i] = min(dp[i], seg.get(j - k - 1, i).x + cc);
                else dp[i] = min(dp[i], cc);
            }
        }
        seg.change(i, dp[i]);
    }
    ll ans = dp[n - 1];
    if (ans == INF) cout << "-1\n";
    else cout << ans << "\n";
}

ll dfs1(ll v, ll p, ll k, ll no, vector<ll>&dp) {
    if (k == -1) return dp[v];
    ll ans = 0;
    for (ll i : g[v]) {
        if (i != p && i != no) {
            ans += dfs1(i, v, k - 1, no, dp);
        }
    }
    if (p != -1 && h[v] > h[p]) ans = min(ans, dp[v]);
    return ans;
}

vector<ll> dfs(ll v, ll p, vector<ll>&dp) {
    vector<ll> q = {v};
    h[v] = 0;
    if (p != -1) h[v] = h[p] + 1;
    for (ll i : g[v]) {
        if (i != p) {
            auto u = dfs(i, v, dp);
            forr(i, u.size()) q.push_back(u[i]);
        }
    }
    for (auto u : q) {
        for (ll i = h[u] - h[v]; i < t[u]; i++) {
            dp[v] = min(dp[v], /*cmn.get(i, t[u]).x*/ c[i] + dfs1(u, -1, i, p, dp));
        }
    }
    return q;
}

void solve2() {
    vector<ll> dp(n, INF);
    h.resize(n);
    dfs(0, -1, dp);
    if (dp[0] < INF) cout << dp[0] << "\n";
    else cout << "-1\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    c.resize(n);
    t.resize(n);
    forr(i, n) cin >> c[i];
    forr(i, n) cin >> t[i];
    g.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<ll> cc = c;
    sort(all(cc));
    if (c != cc) exit(-1);
    cmn = Segtree(c);
    if (n <= 75) solve2();
    else solve1();
    return 0;
}