﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
const ll MAXN = 1e5 + 20;
const ll K = 1300;
ll binpow(ll a, ll n) {
    ll ans = 1;
    ll k = a;
    while (n > 0) {
        if (n % 2) ans *= k;
        k *= k;
        n /= 2;
    }
    return ans;
}

vector<pair<ll, ll>> r(ll n) {
    ll i = 2;
    vector < pair<ll, ll>> ans;
    while (i * i <= n) {
        ll k= 0;
        while (n % i == 0) k++, n /= i;
        if (k > 0) ans.push_back({i, k});
        i++;
    }
    if (n > 1) ans.push_back({n, 1});
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<ll> v(MAXN, 0);
    for (ll i = 1; i < MAXN; i++) {
        auto p = r(i);
        ll ans = 1;
        for (auto pp : p) {
            ans *= (binpow(pp.first, pp.second + 1) - 1) / (pp.first - 1);
        }
        ans -= i;
        v[i] = ans;
    }
    vector<vector<ll>> a(MAXN / K + 10);
    for (ll i = 0; i < MAXN; i++) {
        a[i / K].push_back(v[i]);
    }
    forr(i, a.size()) sort(all(a[i]));
    ll q;
    cin >> q;
    while (q--) {
        ll l, r, k;
        cin >> l >> r >> k;
        ll ans = 0;
        while (l <= r) {
            if (l % K == 0 && l + K <= r + 1) {
                ll u = a[l / K].end() - upper_bound(all(a[l / K]), k);
                ans += u;
                l += K;
            } else {
                ans += (v[l] > k);
                l++;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}