﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>

using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
const ll MAXN = 1e5 + 20;
const ll MAXD = 3e5 + 5000;
const ll K = 330;
long long binpow(ll a, ll n) {
    long long ans = 1;
    long long k = a;
    while (n > 0) {
        if (n % 2) ans *= k;
        k *= k;
        n /= 2;
    }
    return ans;
}

vector<pair<ll, ll>> r(ll n) {
    ll i = 2;
    vector < pair<ll, ll>> ans;
    while (i * i <= n) {
        ll k= 0;
        while (n % i == 0) k++, n /= i;
        if (k > 0) ans.push_back({i, k});
        i++;
    }
    if (n > 1) ans.push_back({n, 1});
    return ans;
}

struct MST {
    struct Node {
        vector<ll> v;
        Node() {}
        Node(ll x) : v({x}) {}
        Node operator+(const Node& other) const {
            Node res = Node();
            ll i = 0, j = 0;
            while (i < v.size() && j < other.v.size()) {
                if (v[i] < other.v[j]) res.v.push_back(v[i]), i++;
                else res.v.push_back(other.v[j]), j++;
            }
            for (ll k = i; k < v.size(); k++) res.v.push_back(v[k]);
            for (ll k = j; k < other.v.size(); k++) res.v.push_back(other.v[k]);
            return res;
        }
    };
    vector<Node> t;
    ll sz;
    MST() {}
    MST(vector<ll>& v) : sz(1) {
        ll n = v.size();
        while (sz < n) sz *= 2;
        t.resize(sz * 2, Node());
        for (ll i = 0; i < n; i++) 
            t[sz + i] = Node(v[i]);
        for (ll i = sz - 1; i >= 1; i--) 
            t[i] = t[i * 2] + t[i * 2 + 1];
    }
    ll get(ll lx, ll rx, ll k, ll v = 1, ll l = 0, ll r = -1) {
        if (r == -1) r = sz;
        if (lx <= l && r <= rx) {
            ll u = t[v].v.end() - upper_bound(all(t[v].v), k);
            return u;
        }
        if (lx >= r || l >= rx) return 0;
        ll mid = (l + r) / 2;
        return get(lx, rx, k, v * 2, l, mid) + get(lx, rx, k, v * 2 + 1, mid, r);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<ll> v(MAXN, 0);
    for (ll i = 1; i < MAXN; i++) {
        if (i == 46349) {
            ll anna = 0;
        }
        auto p = r(i);
        long long ans = 1;
        for (auto pp : p) {
            ans *= ((long long)binpow(pp.first, pp.second + 1) - 1) / (pp.first - 1);
        }
        ans -= i;
        v[i] = ans;
    }
    //MST ms = MST(v);
    //cout << *max_element(all(v)) << "\n";
    //cout << v[46348] << "\n";
    vector<vector<ll>> a(MAXN / K + 10, vector<ll>(MAXN, 0));
    for (ll i = 0; i < MAXN; i++) {
        a[i / K][min(MAXN-1, v[i])]++;
    }
    for (ll i = 0; i < a.size(); i++) {
        for (ll j = 1; j < MAXN; j++) {
            a[i][j] += a[i][j - 1];
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        ll l, r, k;
        cin >> l >> r >> k;
        ll ans = 0;
        while (l <= r) {
            if (l % K == 0 && l + K <= r + 1) {
                ans += a[l / K].back() - a[l / K][k];
                l += K;
            } else {
                ans += (v[l] > k);
                l++;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}