﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
//#include "coins.h"
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define forr(i, n) for (ll i = 0;i<n;i++)
mt19937 rng(0);
const ll INF = 1e14;

const ll MAXN = (1<<17);
ll MAXD = 15;
const ll K = 330;
long long binpow(ll a, ll n) {
    long long ans = 1;
    long long k = a;
    while (n > 0) {
        if (n % 2) ans *= k;
        k *= k;
        n /= 2;
    }
    return ans;
}

vector<pair<ll, ll>> r(ll n) {
    ll i = 2;
    vector < pair<ll, ll>> ans;
    while (i * i <= n) {
        ll k = 0;
        while (n % i == 0) k++, n /= i;
        if (k > 0) ans.push_back({i, k});
        i++;
    }
    if (n > 1) ans.push_back({n, 1});
    return ans;
}

struct MST {
    struct Node {
        vector<ll> v;
        Node() {}
        Node(ll x) : v({x}) {}
        Node operator+(const Node& other) const {
            Node res = Node();
            ll i = 0, j = 0;
            while (i < v.size() && j < other.v.size()) {
                if (v[i] < other.v[j]) res.v.push_back(v[i]), i++;
                else res.v.push_back(other.v[j]), j++;
            }
            for (ll k = i; k < v.size(); k++) res.v.push_back(v[k]);
            for (ll k = j; k < other.v.size(); k++) res.v.push_back(other.v[k]);
            return res;
        }
    };
    vector<Node> t;
    ll sz;
    MST() {}
    MST(vector<ll>& v) : sz(1) {
        ll n = v.size();
        while (sz < n) sz *= 2;
        t.resize(sz * 2, Node());
        for (ll i = 0; i < n; i++)
            t[sz + i] = Node(v[i]);
        for (ll i = sz - 1; i >= 1; i--)
            t[i] = t[i * 2] + t[i * 2 + 1];
    }
    ll get(ll lx, ll rx, ll k, ll v = 1, ll l = 0, ll r = -1) {
        if (r == -1) r = sz;
        if (lx <= l && r <= rx) {
            ll u = t[v].v.end() - upper_bound(all(t[v].v), k);
            return u;
        }
        if (lx >= r || l >= rx) return 0;
        ll mid = (l + r) / 2;
        return get(lx, rx, k, v * 2, l, mid) + get(lx, rx, k, v * 2 + 1, mid, r);
    }
};

/*struct Node {
    ll x;
    Node* l, * r;
    ll lef, rig;
    Node() : x(0), l(nullptr), r(nullptr), lef(-1), rig(-1) {}
    Node(ll l, ll r) : x(0), l(nullptr), r(nullptr), lef(l), rig(r) {}
};
Node* root = new Node(0, MAXN);
void build(Node* v) {
    if (v->lef + 1 == v->rig) return;
    ll mid = (v->lef + v->rig) / 2;
    v->l = new Node(v->lef, mid);
    v->r = new Node(v->rig, mid);
    build(v->l);
    build(v->r);
}
Node* change(ll i, Node* u) {
    Node* v = new Node(u->lef, u->rig);
    v->x = u->x + 1;
    if (v->lef + 1 == v->rig) {
        return v;
    }
    ll mid = (v->lef + v->rig) / 2;
    if (i < mid) {
        v->r = u->r;
        v->l = change(i, u->l);
        return v;
    } else {
        v->l = u->l;
        v->r = change(i, u->r);
        return v;
    }
}
ll get(Node* v, ll l, ll r) {
    if (l <= v->lef && v->rig <= r) {
        return v->x;
    }
    if (l >= v->lef)
}*/
struct Segtree {
    struct Node {
        ll x;
        Node() : x(0) {}
        Node(ll x) : x(x) {}
        Node operator+(const Node& other) const {
            Node res = Node(x+other.x);
            return res;
        }
    };
    vector<ll> t;
    ll sz = MAXN;
    Segtree() {}
    Segtree(vector<ll>& v) : sz(1) {
        ll n = v.size();
        while (sz < n) sz *= 2;
        t.resize(MAXN * 2, 0);
        for (ll i = 0; i < n; i++)
            t[sz + i] = v[i];
        for (ll i = sz - 1; i >= 1; i--)
            t[i] = t[i * 2] + t[i * 2 + 1];
    }
    void change(ll i, ll d) {
        t[sz + i] += d;
        ll v = (sz + i) / 2;
        while (v > 0) {
            t[v] = t[v * 2] + t[v * 2 + 1];
            v /= 2;
        }
    }
    ll get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
        if (r == -1) r = sz;
        if (lx <= l && r <= rx) return t[v];
        if (lx >= r || l >= rx) return 0;
        ll mid = (l + r) / 2;
        return get(lx, rx, v * 2, l, mid) + get(lx, rx, v * 2 + 1, mid, r);
    }
};
struct Z {
    ll x, k, i;
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<char> isp(MAXN, 1);
    vector<ll> p;
    for (ll i = 2; i < MAXN; i++) {
        if (isp[i]) {
            p.push_back(i);
            for (ll j = i * 2; j < MAXN; j += i) isp[j] = 0;
        }
    }
    vector<ll> v(MAXN, 0), low(MAXN, MAXN);
    for (ll i : p) low[i] = i;
    v[1] = 1;
    for (ll i = 2; i < MAXN; i++) {
        for (ll j = 0; p[j] <= low[i] && j < p.size() && i * p[j] < MAXN; j++) {
            low[i * p[j]] = p[j];
        }
        ll m = i, k = 0;
        while (m % low[i] == 0) {
            m /= low[i];
            k++;
        }
        v[i] = v[m] * ((binpow(low[i], k + 1) - 1) / (low[i] - 1));
    }
    for (ll i = 0; i < MAXN; i++) 
        v[i] = min(MAXN - 1, v[i] - i);
    ll q;
    cin >> q;
    vector<Z> z;
    vector<ll> ans(q);
    for (ll i = 0; i < q; i++) {
        ll l, r, k;
        cin >> l >> r >> k;
        z.push_back({l - 1, k, -i});
        z.push_back({r, k, i + 1});
    }
    sort(all(z), [](Z a, Z b) {
        return a.x < b.x;
        });
    vector<ll> vv(MAXN, 0);
    Segtree seg = Segtree(vv);
    ll j = 0;
    for (ll i = 0; i < MAXN; i++) {
        seg.change(v[i], 1);
        while (j < z.size() && z[j].x == i) {
            if (z[j].i > 0) ans[z[j].i - 1] += seg.get(z[j].k + 1, MAXN);
            else ans[-z[j].i] -= seg.get(z[j].k + 1, MAXN);
            j++;
        }
    }
    for (ll i : ans) cout << i << "\n";
    //MST ms = MST(v);
    //cout << *max_element(all(v)) << "\n";
    //cout << v[46348] << "\n";
    
    return 0;
}