#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 2000000001;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void dfs1(ll v, ll p, ll rn, vector<vector<pair<ll, ll>>>& arr, vector<vector<vector<ll>>>& dp, vector<ll>& c, vector<ll>& t) {
	for (auto[i, nr] : arr[v]) {
		if (i != p) {
			dfs1(i, v, nr, arr, dp, c, t);
		}
	}
	if (p == v) {
		return;
	}
	ll ma = INF;
	for (ll np = 1; np <= t[v]; np++) {
		ll now = c[np];
		for (auto[i, nr] : arr[v]) {
			if (i != p) {
				now += dp[i][nr][np - 1];
			}
		}
		assign_min(ma, now);
	}
	dp[v][rn][0] = ma;
	for (ll np = 1; np <= arr.size(); np++) {
		dp[v][rn][np] = ma;
		ll now = 0;
		for (auto[i, nr] : arr[v]) {
			if (i != p) {
				now += dp[i][nr][np - 1];
			}
		}
		assign_min(dp[v][rn][np], now);
	}
}

void dfs2(ll v, ll p, ll rn, vector<vector<pair<ll, ll>>>& arr, vector<vector<vector<ll>>>& dp, vector<ll>& c, vector<ll>& t) {
	vector<ll> ma(arr[v].size(), INF);
	for (ll np = 1; np <= t[v]; np++) {
		ll now = c[np];
		for (auto[i, nr] : arr[v]) {
			now += dp[i][nr][np - 1];
		}
		for (ll j = 0; j < arr[v].size(); j++) {
			assign_min(ma[j], now - dp[arr[v][j].first][arr[v][j].second][np - 1]);
		}
	}
	for (ll j = 0; j < arr[v].size(); j++) {
		dp[v][j][0] = ma[j];
	}
	for (ll np = 1; np <= arr.size(); np++) {
		for (ll j = 0; j < arr[v].size(); j++) {
			dp[v][j][np] = ma[j];
		}
		ll now = 0;
		for (auto[i, nr] : arr[v]) {
			now += dp[i][nr][np - 1];
		}
		for (ll j = 0; j < arr[v].size(); j++) {
			assign_min(dp[v][j][np], now - dp[arr[v][j].first][arr[v][j].second][np - 1]);
		}
	}
	for (auto[i, nr] : arr[v]) {
		if (i != p) {
			dfs2(i, v, nr, arr, dp, c, t);
		}
	}
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> c(n + 1, 0);
	vector<ll> t(n);
	for (ll i = 1; i <= n; i++) {
		cin >> c[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> t[i];
	}
	vector<vector<pair<ll, ll>>> arr(n);
	for (ll i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		arr[a].emplace_back(b, arr[b].size());
		arr[b].emplace_back(a, arr[a].size() - 1);
	}
	vector<vector<vector<ll>>> dp(n), dp2(n);
	for (ll i = 0; i < n; i++) {
		dp[i].resize(arr[i].size(), vector<ll>(n + 1));
		dp2[i].resize(arr[i].size(), vector<ll>(n + 1));
	}
	dfs1(0, 0, -1, arr, dp, c, t);
	dfs2(0, 0, -1, arr, dp, c, t);
	ll ans = INF;
	for (ll i = 0; i < n; i++) {
		for (ll j = 1; j <= t[i]; j++) {
			ll now = c[j];
			for (auto[to, rt] : arr[i]) {
				now += dp[to][rt][j - 1];
			}
			assign_min(ans, now);
		}
	}
	cout << (ans == INF ? -1 : ans) << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
