#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 2000000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void dfs(ll v, ll p, vector<bool>& used, vector<vector<ll>>& arr, ll nd, ll md) {
	if (nd >= md) {
		return;
	}
	used[v] = true;
	for (auto i : arr[v]) {
		if (i != p) {
			dfs(i, v, used, arr, nd + 1, md);
		}
	}
}

bool check(vector<ll>& t, vector<vector<ll>>& arr) {
	vector<bool> used(arr.size(), false);
	for (ll i = 0; i < arr.size(); i++) {
		dfs(i, i, used, arr, 0, t[i]);
	}
	for (auto i : used) {
		if (!i) {
			return false;
		}
	}
	return true;
}

ll rec(vector<ll>& now, vector<ll>& c, vector<ll>& t, vector<vector<ll>>& arr) {
	if (now.size() == t.size()) {
		if (check(now, arr)) {
			return 0;
		}
		return INF;
	}
	now.push_back(0);
	ll ans = INF;
	for (; now.back() < t[now.size() - 1]; now.back()++) {
		assign_min(ans, rec(now, c, t, arr) + c[now.back()]);
	}
	now.pop_back();
	return ans;
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> c(n + 1, 0), t(n);
	for (ll i = 1; i <= n; i++) {
		cin >> c[i];
	}
	for (ll i = 0; i < n; i++) {
		cin >> t[i];
		t[i]++;
	}
	vector<vector<ll>> arr(n);
	for (ll i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		arr[a].push_back(b);
		arr[b].push_back(a);
	}
	vector<ll> now;
	ll ans = rec(now, c, t, arr);
	cout << (ans == INF ? -1 : ans) << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
