#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll MAXN = 100000;

struct segment_tree {
	vector<vector<ll>> tree;
	ll size;
	segment_tree(vector<ll>& arr) {
		size = arr.size();
		tree.resize(size * 4);
		build(1, 0, size, arr);
	}
	void build(ll v, ll l, ll r, vector<ll>& arr) {
		if (r - l == 1) {
			tree[v] = vector<ll>(1, arr[l]);
			return;
		}
		ll mid = (l + r) / 2;
		build(v * 2, l, mid, arr);
		build(v * 2 + 1, mid, r, arr);
		tree[v].resize(tree[v * 2].size() + tree[v * 2 + 1].size());
		merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), tree[v].begin());
	}
	ll get(ll l, ll r, ll x) {
		return get(1, 0, size, l, r, x);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr, ll x) {
		if (ql <= l && r <= qr) {
			return tree[v].end() - upper_bound(tree[v].begin(), tree[v].end(), x);
		}
		if (qr <= l || r <= ql) {
			return 0;
		}
		ll mid = (l + r) / 2;
		return get(v * 2, l, mid, ql, qr, x) + get(v * 2 + 1, mid, r, ql, qr, x);
	}
};

void solve() {
	ll q;
	cin >> q;
	vector<ll> sd(MAXN, 0);
	for (ll i = 1; i <= MAXN; i++) {
		for (ll j = 2; i*j <= MAXN; j++) {
			sd[i * j - 1] += i;
		}
	}
	segment_tree st(sd);
	for (ll i = 0; i < q; i++) {
		ll l, r, v;
		cin >> l >> r >> v;
		l--;
		cout << st.get(l, r, v) << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
