#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 2000000000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll MAXN = 100000;

struct segment_tree {
	vector<ll> tree;
	ll size;
	segment_tree(ll sz) {
		size = sz;
		tree.resize(size * 4, 0);
	}
	ll get(ll l, ll r) {
		return get(1, 0, size, l, r);
	}
	ll get(ll v, ll l, ll r, ll ql, ll qr) {
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		if (qr <= l || r <= ql) {
			return 0;
		}
		ll mid = (l + r) / 2;
		return get(v * 2, l, mid, ql, qr) + get(v * 2 + 1, mid, r, ql, qr);
	}
	void change(ll l, ll x) {
		return change(1, 0, size, l, x);
	}
	void change(ll v, ll l, ll r, ll qx, ll x) {
		if (qx < l || qx >= r) {
			return;
		}
		if (r - l == 1) {
			tree[v] = x;
			return;
		}
		ll mid = (l + r) / 2;
		change(v * 2, l, mid, qx, x);
		change(v * 2 + 1, mid, r, qx, x);
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
};

void solve() {
	ll q;
	cin >> q;
	vector<ll> sd(MAXN, 0);
	for (ll i = 1; i <= MAXN; i++) {
		for (ll j = 2; i*j <= MAXN; j++) {
			sd[i * j - 1] += i;
		}
	}
	vector<pair<ll, ll>> all;
	for (ll i = 0; i < MAXN; i++) {
		all.push_back(make_pair(sd[i], i));
	}
	sort(all.begin(), all.end());
	segment_tree st(MAXN);
	vector<tuple<ll, ll, ll, ll>> qs(q);
	vector<ll> ans(q);
	ll last = 0, u = 0;
	for (auto&[v, l, r, i] : qs) {
		cin >> l >> r >> v;
		l--;
		i = last;
		last++;
	}
	sort(qs.begin(), qs.end());
	for (auto[v, l, r, i] : qs) {
		while (u != all.size() && all[u].first <= v) {
			st.change(all[u].second, 1);
			u++;
		}
		ans[i] = (r - l) - st.get(l, r);
	}
	for (auto i : ans) {
		cout << i << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
