#include "bits/stdc++.h"
using namespace std;

#define all(x) x.begin(), x.end()

const int N = 1e5 + 1;

int d[N];
vector<int> tr[4 * N];

void build(int node = 1, int l = 1, int r = N - 1) {
    if (l == r) {
        tr[node] = {d[l]};
        return;
    }
    int mid = (l + r) >> 1;
    build(node << 1, l, mid);
    build(node << 1 | 1, mid + 1, r);
    merge(all(tr[node << 1]), all(tr[node << 1 | 1]), back_inserter(tr[node]));
}

int get(int ql, int qr, int x, int node = 1, int l = 1, int r = N - 1) {
    if (ql <= l && r <= qr) {
        return tr[node].size() - (upper_bound(all(tr[node]), x) - tr[node].begin());
    }
    if (r < ql || qr < l) return 0;
    int mid = (l + r) >> 1;
    return get(ql, qr, x, node << 1, l, mid) + get(ql, qr, node << 1 | 1, mid + 1, r);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    for (int i = 1; i < N; ++i) for (int j = 2 * i; j < N; j += i) d[j] += i;

    int q;
    cin >> q;
    while (q--) {
        int l, r, v;
        cin >> l >> r >> v;
        int cnt = 0;
        for (int i = l; i <= r; ++i) cnt += d[i] > v;
        cout << cnt << '\n';
    }
}