#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)x.size()
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e5 + 10;
const int OO = 1e18;
int sigma[N], min_div[N], t[N];

struct Query
{
    int l, r, idx;

    Query(int l, int r, int idx) : l(l), r(r), idx(idx) {};
};

vec<Query> qs[N];
vec<int> get_values_by_sigma[N];

void change(int idx, int val)
{
    while (idx < N) t[idx] += val, idx |= idx + 1;
}

int get(int idx)
{
    int res = 0;
    for (; idx >= 0; idx = (idx & (idx + 1)) - 1) res += t[idx];
    return res;
}

int get(int l, int r)
{
    return get(r) - get(l - 1);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for (int i = 2; i < N; i++) min_div[i] = i;
    for (int i = 2; i < N; i++)
    {
        if (min_div[i] == i)
        {
            for (int j = i; j < N; j += i)
                min_div[j] = min(min_div[j], i);
        }
        sigma[i] = 1;
        int t = i;
        while (t != 1)
        {
            int mn = min_div[t];
            int s = 1, cur = 1;
            while (min_div[t / mn] == mn)
            {
                t /= mn;
                cur *= mn;
                s += cur;
            }
            t /= mn;
            s += cur * mn;
            sigma[i] *= s;
        }
        sigma[i] -= i;
        get_values_by_sigma[min(N - 1, sigma[i])].pb(i);
    }
    int q;
    cin >> q;
    for (int t = 0; t < q; t++)
    {
        int l, r, v;
        cin >> l >> r >> v;
        qs[v].pb(Query(l, r, t));
    }
    vec<int> res(q);
    for (int i = 2; i < N; i++) change(i, +1);
    for (int val = 1; val < N; val++)
    {
        for (int &idx : get_values_by_sigma[val]) change(idx, -1);
        for (Query &q : qs[val])
        {
            res[q.idx] = get(q.l, q.r);
        }
    }
    for (int i = 0; i < q; i++) cout << res[i] << "\n";
    return 0;
}
