﻿// rich_num.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <iterator>

using namespace std;
using ll = long long;

struct q 
{
	ll r;
	ll l;
	ll v;
	ll place;
};

struct place 
{
	ll rich;
	ll num;

	place() 
	{
		rich = 0;
	}
};


void add_rich_at(vector<place>& rich_at, ll n) 
{

	for (int i = 2 * n; i < rich_at.size(); i += n)
	{
		rich_at[i].rich += n;
	}

}
bool comp_q(const q a, const q b)
{
	return a.v < b.v;
}
bool comp_place(const place& a, const place& b)
{
	return a.rich < b.rich;
}

void change_in_segment_tree(ll place, ll to, vector<ll>& add)
{


	for (int i = add.size() - place; i > 0; i /= 2)
	{
		add[i] += 1;
	}
}

void add_to_segment_tree(q& value, vector<place>& rich_at, vector<ll>& add)// לחזור לזה
{
	place temp;
	temp.rich = value.v;
	auto upper = upper_bound(rich_at.begin(), rich_at.end(), temp, comp_place);

	int from = distance(rich_at.begin(), upper);

	while (from < rich_at.size())
	{
		change_in_segment_tree(rich_at[rich_at.size() - 1].num, 1, add);
		rich_at.pop_back();
	}
}
ll q_for_segment_tree(vector<ll>& add, ll left, ll right, ll count)
{

	if (right == left)
	{
		count += add[right];
		return count;
	}
	else if (right + 1 == left)
	{
		count += add[right] + add[left];
		return count;
	}
	if (right % 2 == 1)
	{
		count += add[right];
		right++;
	}
	right /= 2;
	if (left % 2 == 0)
	{
		count += add[left];
		left--;
	}
	left /= 2;
	return q_for_segment_tree(add, left, right, count);
}
ll size_segment_tree() 
{
	ll start = pow(2, 17);

	for (int i = start/2; i > 0; i /= 2)
	{
		start += i;
	}
	start++;
	return start;
}



int main()
{
	ios_base::sync_with_stdio(false);

	ll n;
	cin >> n;
	ll max_r = 0;
	vector<q> all_q(n);
	vector<ll> ans(n);
	vector<ll> add(size_segment_tree());


	for (int i = 0; i < all_q.size(); i++)
	{
		cin >> all_q[i].l >> all_q[i].r >> all_q[i].v;
		all_q[i].place = i;
		if (all_q[i].r > max_r)
		{
			max_r = all_q[i].r;
		}
	}
	vector<place> rich_at(max_r + 1);
	for (int i = 1; i < rich_at.size(); i++) 
	{
		rich_at[i].num = i;
		add_rich_at(rich_at, i);
	}

	sort(all_q.begin(), all_q.end(), comp_q);
	sort(rich_at.begin(), rich_at.end(), comp_place);

	for (int i = all_q.size()- 1; i >= 0 ; i--)
	{
		add_to_segment_tree(all_q[i], rich_at, add);
		ans[all_q[i].place] = q_for_segment_tree(add, add.size() - all_q[i].l, add.size() - all_q[i].r, 0);
	}

	for (int i = 0; i < n; i++) 
	{
		cout << ans[i] << endl;
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
