// C
#include <iostream>
#include <vector>


using namespace std;

#define ll long long

ll power(ll a, ll b)
{
	if (b==0)
		return 1;
	ll val = power(a,b/2);
	val*=val;
	if (b%2==1)
		val*=a;
	return val;
}

const ll N = 1e5+10;
ll spf[N];
// ll sum_prime_power[N];
ll sum_div[N];

void sieve()
{
	for (ll i=1; i<N; i++)
		spf[i] = i;
	for (ll i=2; i<N; i+=2)
		spf[i] = 2;
	for (ll i=3; i*i<N; i++)
	{
		if (spf[i]==i)
			for (ll j=i*i; j<N; j+=i)
			{
				if (spf[j]==j)
					spf[j] = i;
			}
	}
}
void preprocess()
{
	for (ll i=2; i<N; i++)
	{
		vector<pair<ll,ll>> primes;
		ll cur = i;
		while (cur!=1)
		{
			ll cnt = 0;
			ll cur_div = spf[cur];
			while (cur%cur_div==0)
			{
				cnt++;
				cur/=cur_div;
			}
			primes.push_back({cur_div, cnt});
		}
		ll temp = 1;
		for (auto j:primes)
		{
			temp*=(((power(j.first, j.second+1)-1)/(j.first-1)));
		}
		sum_div[i] = temp;
	}
}



int main()
{
	sieve();
	preprocess();
	ll q;
	cin >> q;
	// calculate sum of divisors.
	// for every prime calculate:
	while (q--)
	{
		ll l,r,v;
		cin >> l >> r >> v;
		ll ans = 0;
		for (ll i=l; i<=r; i++)
			if ((sum_div[i]-i)>v)
				ans++;
		cout << ans << endl;
	}
}