// C
#include <iostream>
#include <vector>


using namespace std;

#define ll long long


const ll N = 1e4+3;
ll spf[N];
// ll sum_prime_power[N];
ll sum_div[N];
ll ans[N][11];
ll power[N][20];
void sieve()
{
	for (ll i=1; i<N; i++)
		spf[i] = i;
	for (ll i=2; i<N; i+=2)
		spf[i] = 2;
	for (ll i=2; i*i<N; i++)
	{
		if (spf[i]==i)
		{
			for (ll j=i*i; j<N; j+=i)
			{
				if (spf[j]==j)
					spf[j] = i;
			}
			ll cur = i;
			power[i][0] = 1;
			for (int j=1; j<20; j++)
			{
				power[i][j] = cur;
				cur*=i;
				if (cur>(N*N))
					break;
			}
		}
	}
}
void preprocess()
{
	for (ll i=2; i<N; i++)
	{
		vector<pair<ll,ll>> primes;
		ll cur = i;
		while (cur!=1)
		{
			ll cnt = 0;
			ll cur_div = spf[cur];
			while (cur%cur_div==0)
			{
				cnt++;
				cur/=cur_div;
			}
			primes.push_back({cur_div, cnt});
		}
		ll temp = 1;
		for (pair<int,int> j:primes)
		{
			temp*=(((power[j.first][j.second+1]-1)/(j.first-1)));
		}
		sum_div[i] = temp;
	}
}



int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	sieve();
	preprocess();
	ll q;
	cin >> q;
	// calculate sum of divisors.
	// for every prime calculate:

	for (int r=0; r<=N; r++)
	{
		for (int i=1; i<=10; i++)
		{
			if (r==0)
			{
				ans[r][i] = 0;
				continue;
			}
			if ((sum_div[r]-r)>i)
				ans[r][i] = ans[r-1][i]+1;
			else
				ans[r][i] = ans[r-1][i];
		}
	}
	while (q--)
	{
		ll l,r,v;
		cin >> l >> r >> v;
		cout << ans[r][v] - ans[l-1][v] << endl;
	}
}


/*
#include <iostream>
#include <vector>


using namespace std;

#define ll long long

ll power(ll a, ll b)
{
    if (b==0)
        return 1;
    ll val = power(a,b/2);
    val*=val;
    if (b%2==1)
        val*=a;
    return val;
}

const ll N = 1e5+10;
ll spf[N];
// ll sum_prime_power[N];
ll sum_div[N];
ll ans[N][11];

void sieve()
{
    for (ll i=1; i<N; i++)
        spf[i] = i;
    for (ll i=2; i<N; i+=2)
        spf[i] = 2;
    for (ll i=3; i*i<N; i++)
    {
        if (spf[i]==i)
            for (ll j=i*i; j<N; j+=i)
            {
                if (spf[j]==j)
                    spf[j] = i;
            }
    }
}
void preprocess()
{
    for (ll i=2; i<N; i++)
    {
        vector<pair<ll,ll>> primes;
        ll cur = i;
        while (cur!=1)
        {
            ll cnt = 0;
            ll cur_div = spf[cur];
            while (cur%cur_div==0)
            {
                cnt++;
                cur/=cur_div;
            }
            primes.push_back({cur_div, cnt});
        }
        ll temp = 1;
        for (auto j:primes)
        {
            temp*=(((power(j.first, j.second+1)-1)/(j.first-1)));
        }
        sum_div[i] = temp;
    }
}



int main()
{
    sieve();
    preprocess();
    ll q;
    cin >> q;
    // calculate sum of divisors.
    // for every prime calculate:
	for (int r=0; r<=(100000); r++)
	{
		for (int i=1; i<=10; i++)
		{
			if (r==0)
			{
				ans[r][i] = 0;
				continue;
			}
			if (sum_div[r]>i)
				ans[r][i] = ans[r-1][i]+1;
			else
				ans[r][i] = ans[r-1][i]+1;
		}
	}
    while (q--)
    {
        ll l,r,v;
        cin >> l >> r >> v;
        ll ans = 0;
        for (ll i=l; i<=r; i++)
            if ((sum_div[i]-i)>v)
                ans++;
        cout << ans << endl;
    }
}
*/