#include <iostream>
#include <vector>
#include <algorithm>
#define pb push_back
#define sz(a) (int)a.size()
using namespace std;
typedef long long ll;
int sumdivs[100001];
struct segment_tree{
    vector < int > st[400001];
    void build(int id , int l , int r){
        if(l + 1 == r) st[id].pb(sumdivs[l]);
        else{
            int mid = (l + r)/2;
            build(2 * id , l , mid);
            build(2 * id + 1 , mid , r);
            st[id].resize(sz(st[2 * id]) + sz(st[2 * id + 1]));
            merge(st[2 * id].begin() , st[2 * id].end() , st[2 * id + 1].begin() , st[2 * id + 1].end() , st[id].begin());
        }
    }
    int query(int id , int l , int r , int &x , int &y , int &val){
        if(r <= x || y <= l) return 0;
        if(x <= l && r <= y) return st[id].end() - upper_bound(st[id].begin() , st[id].end() , val);
        int mid = (l + r)/2;
        return query(2 * id , l , mid , x , y , val) + query(2 * id + 1 , mid , r , x , y , val);
    }
};
int main()
{
    int t; cin >> t;
    for(int i = 1 ; i <= 100000 ; i++){
        for(int j = 2*i ; j <= 100000 ; j += i){
            sumdivs[j] += i;
        }
    }
    segment_tree xd;
    xd.build(1 , 0 , 100001);
    int l , r , v;
    while(t--){
        cin >> l >> r >> v;
        r++;
        cout << xd.query(1 , 0 , 100001 , l , r , v) << "\n";
    }
    return 0;
}
