#include <iostream>
#include <vector>
using namespace std;
const int nmax = 2e3;
const int oo = 2e9;

vector < int > g[nmax + 1];
int c[nmax + 1];
int t[nmax + 1];

int dp[nmax + 1];
int a[nmax + 1];

int aint[2 * nmax + 2], n;

void build ( int node = 0, int st = 1, int dr = n ) {
    if ( st == dr ) {
        aint[node] = dp[st];
        return;
    }
    int mij = ( st + dr ) / 2;
    build ( node + 1, st, mij );
    build ( node + 2 * ( mij - st + 1 ), mij + 1, dr );
    aint[node] = min ( aint[node + 1], aint[node + 2 * ( mij - st + 1) ] );
}

void update ( int node, int st, int dr, int poz, int val ) {
    if ( st == dr ) {
        aint[node] = val;
        return;
    }
    int mij = ( st + dr ) / 2;
    if ( poz <= mij )
        update ( node + 1, st, mij, poz, val );
    else
        update ( node + 2 * ( mij - st + 1 ), mij + 1, dr, poz, val );
    aint[node] = min ( aint[node + 1], aint[node + 2 * ( mij - st + 1 )] );
}

int query ( int node, int st, int dr, int a, int b ) {
    if ( a == st && b == dr )
        return aint[node];
    int mij = ( st + dr ) / 2;
    if ( b <= mij )
        return query ( node + 1, st, mij, a, b );
    if ( a > mij )
        return query ( node + 2 * ( mij - st + 1 ), mij + 1, dr, a, b );
    return min ( query ( node + 1, st, mij, a, mij ), query ( node + 2 * ( mij - st + 1 ), mij + 1, dr, mij + 1, b ) );
}

int main() {
    ios_base::sync_with_stdio ( false );
    cin.tie ( 0 );
    cout.tie ( 0 );

    int x, y;
    cin >> n;
    /// the graph is a chain
    for ( int i = 1; i <= n; i++ )
        cin >> c[i];

    for ( int i = 1; i <= n; i++ )
        cin >> t[i];

    for ( int i = 1; i < n; i++ ) {
        cin >> x >> y;
        g[x].push_back ( y );
        g[y].push_back ( x );
    }
    int i = 1;
    while ( i <= n && g[i].size () == 2 )
        i++;

    a[1] = i;
    a[2] = g[i][0];
    for ( int i = 3; i <= n; i++ )
        a[i] = g[a[i - 1]][0] + g[a[i - 1]][1] - a[i - 2];

    dp[0] = 0;
    for ( int i = 1; i <= n; i++ )
        dp[i] = oo;
    build ( 0, 0, n );

    for ( int i = 1; i <= n; i++ )
        for ( int j = 1; j <= t[a[i]]; j++ ) {
            int poz = min ( i + j - 1, n );
            int x = query ( 0, 0, n, i - j, i - 1 );
           /// cout << i << ' ' << j << ' ' << poz << ' ' << x << ' ' << x + c[j] <<'\n';
            if ( dp[poz] > x + c[j] )
                dp[poz] = x + c[j], update ( 0, 0, n, poz, dp[poz] );
        }
    if ( dp[n] == oo )
        cout << -1;
    else
        cout << dp[n];
    /**
    cout << '\n';
    for ( int i = 1; i <= n; i++ )
        if ( dp[i] == oo )
            cout << -1 << ' ';
        else
            cout << dp[i] << ' '; **/

    return 0;
}
