#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const int nmax = 1e5;

int ciur[nmax + 1];
vector < int > v[nmax + 1];

struct query {
    int ind, val, add, I;
} a[2 * nmax];

bool cmp ( query a, query b ) {
    return a.val < b.val;
}

int ans[nmax];

struct fenwick {
    int aib[nmax + 1];
    int N;

    void update ( int poz, int add ) {
        for ( ; poz <= N; poz += poz & -poz )
            aib[poz] += add;
    }

    int query ( int poz ) {
        int s = 0;
        for ( ; poz > 0; poz -= poz & -poz )
            s += aib[poz];
        return s;
    }
}aib;

int main() {
    ios_base::sync_with_stdio ( false );
    cin.tie ( 0 );
    cout.tie ( 0 );

    int q, l, r, x, k = 0, xmax = 0, indmax = 0;
    cin >> q;
    for ( int i = 0; i < q; i++ ) {
        cin >> l >> r >> x;
        a[k++] = { r, x, +1, i };
        a[k++] = { l - 1, x, -1, i };
        xmax = max ( xmax, x );
        indmax = max ( indmax, x );
    }

    for ( int i = 1; i <= indmax; i++ )
        for ( int j = 2 * i; j <= indmax; j += i )
            ciur[j] += i;

    for ( int i = 1; i <= xmax; i++ )
        if ( ciur[i] < xmax )
            v[ciur[i]].push_back ( i );

    sort ( a, a + k, cmp );
    int ind = 0, cnt = 0;

    aib.N = xmax;
    for ( int i = 0; i < a[0].val; i++ )
        for ( int &x: v[i] )
            aib.update ( x, +1 );

    for ( int i = a[0].val; ind < k; i++ ) {
        for ( int &x: v[i] )
            aib.update ( x, +1 ), cnt++;
        while ( ind < k && a[ind].val == i ) {
            ans[a[ind].I] += a[ind].add * ( a[ind].ind - aib.query ( a[ind].ind ) );
            ind++;
        }
    }


    for ( int i = 0; i < q; i++ )
        cout << ans[i] << '\n';

    return 0;
}

