#include <bits/stdc++.h>
#define ll long long
#define pii pair <int, int>
#define x first
#define y second
#pragma GCC optimize("Ofast")

using namespace std;

const int INF = 1e9;

int n, c[2005], t[2005];
vector <int> g[2005], order;

void dfs(int nod, int tata = 0) {
    for (auto& fiu : g[nod]) {
        if (fiu == tata)
            continue;

        dfs(fiu, nod);
    }
    order.push_back(nod);
}

class SegmentTree {
private:
    vector<int> aint;
    vector<int> lazy;
public:
    void init(int n) {
        aint.resize(4 * n + 1);
        lazy.resize(4 * n + 1);
        for (int i = 1; i <= 4 * n; i++)
            aint[i] = lazy[i] = INF;
    }
    void push(int v) {
        aint[2 * v] = min(aint[2 * v], lazy[v]);
        aint[2 * v + 1] = min(aint[2 * v + 1], lazy[v]);
        lazy[2 * v] = min(lazy[2 * v], lazy[v]);
        lazy[2 * v + 1] = min(lazy[2 * v + 1], lazy[v]);
        lazy[v] = INF;
    }
    void update(int v, int l, int r, int p, int q, int val) {
        if (p > q) {
            return;
        }
        else if (p <= l && r <= q) {
            aint[v] = min(aint[v], val);
            lazy[v] = min(lazy[v], val);
            return;
        }
        push(v);
        int mid = (l + r) / 2;
        update(2 * v, l, mid, p, min(mid, q), val);
        update(2 * v + 1, mid + 1, r, max(p, mid + 1), q, val);
        aint[v] = min(aint[2 * v], aint[2 * v + 1]);
    }
    int query(int v, int l, int r, int p, int q) {
        if (p > q) {
            return INF;
        }
        else if (p <= l && r <= q) {
            return aint[v];
        }
        push(v);
        int mid = (l + r) / 2;
        return min(query(2 * v, l, mid, p, min(mid, q)), query(2 * v + 1, mid + 1, r, max(p, mid + 1), q));
    }
};

SegmentTree aint[2005];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> t[i];

    for (int i = 1; i < n; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    for (int i = 1; i <= n; i++) {
        if (g[i].size() == 1) {
            dfs(i);
            break;
        }
    }
    reverse(order.begin(), order.end());

    for (int i = 0; i <= n; i++)
        aint[i].init(n);
    if (n > 500)
        return 0;
    
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++)
            aint[i].update(1, 1, n, j, j, aint[i - 1].query(1, 1, n, j, j));
        if (n > 500) 
            continue;
        
        for (int j = 1; j <= t[order[i - 1]]; j++) {
            int val;
            if (i - j <= 0)
                val = c[j];
            else
                val = aint[i - 1].query(1, 1, n, i - j, i - j) + c[j];
            aint[i].update(1, 1, n, i, min(n, i + j - 1), val);
        }
    }

    int ans = aint[n].query(1, 1, n, n, n);
    if (ans == INF) {
        cout << "-1";
        return 0;
    }
    cout << ans;

    return 0;
}
