#include <iostream>
#include <vector>

using namespace std;

const int maxn = 2000;
int c[maxn + 1], t[maxn + 1];
vector<int> adj[maxn + 1];

void dfs(int node, int depth, int &pmax, bool *visited) {
    visited[node] = true;
    pmax = max(pmax, depth);
    for (int a: adj[node])
        if (!visited[a])
            dfs(a, depth + 1, pmax, visited);
}

bool hasDepth(int node, int p) {
    bool visited[maxn + 1];
    for (int i = 1; i <= maxn; i++)
        visited[i] = false;
    int pmax = 0;
    dfs(node, 0, pmax, visited);
    return pmax >= p;
}

int getSol(vector<int> combs, int n) {
    int p = 1;
    bool stop = false;
    int sol = 2e5;
    while (p <= n) {
        bool next = false;
        for (int a: combs)
            if (p > t[a]) {
                next = true;
                break;
            }
        if (next)
            break;
        for (int a: combs)
            if (!hasDepth(a, p - 1)) {
                next = true;
                break;
            }
        if (next) {
            p++;
            continue;
        }
        int aux = 0;
        for (int a: combs)
            aux += c[p];
        sol = min(aux, sol);
        p++;
    }
    return sol;
}

int sol1(int n) {
    int sol = 2e5;
    for (int i = 1; i < (1<<n); i++) {
        vector<int> combs;
        int cop = i;
        while (cop > 0) {
            int lsb = cop&-cop;
            combs.push_back(__builtin_ctz(lsb));
            cop -= lsb;
        }
        sol = min(sol, getSol(combs, n));
    }
    return sol;
}

int sol2(int n) {

}

int main() {
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> c[i];
    for (int i = 1; i <= n; i++)
        cin >> t[i];
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    if (n <= 8)
        cout << sol1(n);
    else
        cout << sol2(n);

    return 0;
}