#include <iostream>
#include <algorithm>

using namespace std;

const int maxn = 1e5;
int nrdiv[maxn + 1];
int answers[maxn];
struct query { int id, l, r, v; } queries[maxn];

bool criteria(query a, query b) {
    if (a.v != b.v)
        return a.v > b.v;
    if (a.l != b.l)
        return a.l < b.l;
    return a.r < b.r;
}

void preprocess() {
    for (int i = 2; i <= maxn; i++) {
        nrdiv[i] = 1;
        int j;
        for (j = 2; j * j < i; j++)
            if (i % j == 0)
                nrdiv[i] += j + i/j;
        if (j *j == i)
            nrdiv[i] += j;
    }
}

void processQueries(int q, int greatest) {
    for (int i = 1; i <= greatest; i++)
        for (int j = 0; j < q; j++)
            if (i >= queries[j].l && i <= queries[j].r && nrdiv[i] > queries[j].v)
                answers[queries[j].id]++;
}

int main() {
    ios_base::sync_with_stdio(false);
    preprocess();
    int q;
    cin >> q;
    int dim = 0;
    for (int tq = 0; tq < q; tq++) {
        queries[tq].id = tq;
        int l, r, v;
        cin >> queries[tq].l >> queries[tq].r >> queries[tq].v;
        dim = max(dim, queries[tq].r);
    }
    sort(queries, queries + q, criteria);
    processQueries(q, dim);
    for (int i = 0; i < q; i++)
        cout << answers[i] << '\n';

    return 0;
}