#include <stdio.h>
#include <ctype.h>

#include <vector>

#define magic_sauce inline __attribute__((always_inline))

magic_sauce int fgetint(){
	int n = 0, ch;

	while( !isdigit( ch = fgetc( stdin ) ) );
	do
		n = n * 10 + ch - '0';
	while( isdigit( ch = fgetc( stdin ) ) );

	return n;
}

const int MAXN = 2000;
const int INF = 1e9;

int maxr[MAXN];
int costr[1 + MAXN];

std::vector<int> adj[MAXN];

int nc;
int chain[MAXN];
int dp[1 + MAXN];

void putchain( int u, int p ){
	chain[nc++] = u;

	for( int v : adj[u] )
		if( v != p )
			putchain( v, u );
}

magic_sauce int min( int a, int b ){ return a < b ? a : b; }

int main(){
	int n, i;
	int R, r;

	n = fgetint();
	for( i = 0 ; i < n ; i++ )
		costr[i] = fgetint();
	for( i = 0 ; i < n ; i++ )
		maxr[i] = fgetint();

	for( i = n - 1 ; i-- ; ){
		int a = fgetint() - 1;
		int b = fgetint() - 1;

		adj[a].push_back( b );
		adj[b].push_back( a );
	}

	// chain solution
	i = 0;
	while( i < n && adj[i].size() != 1 )
		i++;

	if( i >= n )
		return 0;

	nc = 0;
	putchain( i, i );

	for( i = 0 ; i < n ; i++ )
		dp[i] = +INF;
	// dp[0] = 0;

	int out = +INF;

	for( i = 0 ; i < n ; i++ ){
		R = maxr[chain[i]];

		for( r = 0 ; r < R ; r++ ){
			int *ans;

			if( i + r < n )
				ans = dp + i + r;
			else
				ans = &out;
			if( i - r - 1 >= 0 ){
				dp[i - r - 1] = min( dp[i - r - 1], dp[i] );
				*ans = min( *ans, costr[r] + dp[i - r - 1] );
			}
			else
				*ans = min( *ans, costr[r] );
		}
	}

	printf( "%d\n", min( out, dp[n - 1] ) );


	return 0;
}