#include <stdio.h>
#include <ctype.h>

#include <vector>

#define magic_sauce inline __attribute__((always_inline))

magic_sauce int fgetint(){
	int n = 0, ch;

	while( !isdigit( ch = fgetc( stdin ) ) );
	do
		n = n * 10 + ch - '0';
	while( isdigit( ch = fgetc( stdin ) ) );

	return n;
}

const int MAXN = 2000;
const int INF = 2e9+123;

int maxr[MAXN];
int costr[MAXN];

std::vector<int> adj[MAXN];

int nc;
int chain[MAXN];
int dp[1 + MAXN];

void putchain( int u, int p ){
	chain[nc++] = u;

	for( int v : adj[u] )
		if( v != p )
			putchain( v, u );
}

magic_sauce int min( int a, int b ){ return a < b ? a : b; }

int aib[1 + MAXN];
int n;

magic_sauce int query( int i ){
	int ret = +INF;

	if( i > n )
		return 0;

	while( i ){
		ret = min( ret, aib[i] );
		i &= (i - 1);
	}

	return ret;
}

magic_sauce void update( int i, int newv ){
	while( i <= n ){
		aib[i] = min( aib[i], newv );
		i += (i & -i);
	}
}

int main(){
	int i;
	int R, r;

	n = fgetint();
	for( i = 0 ; i < n ; i++ )
		costr[i] = fgetint();
	for( i = 0 ; i < n ; i++ )
		maxr[i] = fgetint();

	for( i = n - 1 ; i-- ; ){
		int a = fgetint() - 1;
		int b = fgetint() - 1;

		adj[a].push_back( b );
		adj[b].push_back( a );
	}

	// chain solution
	i = 0;
	while( i < n && adj[i].size() > 1 )
		i++;

	if( i >= n )
		return 0;

	nc = 0;
	putchain( i, i );

	for( i = 0 ; i < n ; i++ )
		dp[i] = +INF;
	for( i = 0 ; i <= n ; i++ )
		aib[i] = +INF;

	for( i = 0 ; i < n ; i++ ){
		R = maxr[chain[i]];

		for( r = 0 ; r < R ; r++ ){
			int ans = min( n - 1, i + r );

			dp[ans] = min( dp[ans], costr[r] + query( n - (i - r - 1) ) );

			update( n - ans, dp[ans] );
		}
	}

	printf( "%d\n", dp[n - 1] == +INF ? -1 : dp[n - 1] );

	return 0;
}