#include <stdio.h>
#include <ctype.h>

#include <vector>

#define magic_sauce inline __attribute__((always_inline))

magic_sauce int fgetint(){
	int n = 0, ch;

	while( !isdigit( ch = fgetc( stdin ) ) );
	do
		n = n * 10 + ch - '0';
	while( isdigit( ch = fgetc( stdin ) ) );

	return n;
}

magic_sauce int min( int a, int b ){ return a < b ? a : b; }

// ----------------------

const int MAXN = 2000;
const int INF = 2e9+123;

int maxr[MAXN];
int costr[MAXN];

std::vector<int> adj[MAXN];
int dep[MAXN];
int par[MAXN];
int preo[MAXN];

int dist[1 + MAXN];
std::vector<int> distl[MAXN];

int st[MAXN];
int dr[MAXN];
int sp;
int n;

int dp[MAXN];
//int aint[4 * MAXN];
//int aintn;

void pre( int u ){
	preo[sp] = u;
	st[u] = sp++;
	dep[u] = dep[par[u]] + 1;

	for( int v : adj[u] )
		if( v != par[u] ){
			par[v] = u;
			pre( v );
		}

	dr[u] = sp;
}

void getdist( int u, int p ){
	for( int v : adj[u] )
		if( v != p ){
			dist[v] = 1 + dist[u];
			distl[dist[v]].push_back( v );
			getdist( v, u );
		}
}

/*

magic_sauce void update( int u, int newv ){
	u += aintn - 1;

	if( newv > aint[u] )
		return;

	aint[u] = newv;

	while( u ){
		u = (u - 1) >> 1;
		aint[u] = min( aint[2 * u + 1], aint[2 * u + 2] );
	}
}

int query( int root, int rl, int rr, int ql, int qr ){
	int mij = (rl + rr) >> 1;

	if( rl == ql && rr == qr ) return aint[root];
	if( qr <= mij ) return query( root * 2 + 1, rl,   mij, ql, qr );
	if( ql >  mij ) return query( root * 2 + 2, mij+1, rr, ql, qr );

	return min(
		query( root * 2 + 1, rl,   mij, ql, mij ),
		query( root * 2 + 2, mij+1, rr, mij + 1, qr )
	);
}

magic_sauce int getdp( int u ){
	return query( 0, 0, aintn - 1, st[u], dr[u] );
}
*/

magic_sauce void upddp( int i, int newv ){
	if( newv >= dp[i] )
		return;

	//dp[i] = newv;
	for( int j = st[i] ; j < dr[i] ; j++ )
		dp[preo[j]] = min( dp[preo[j]], newv );
}

int main(){
	int i, highest;
	int R, r;

	n = fgetint();
	for( i = 0 ; i < n ; i++ )
		costr[i] = fgetint();
	for( i = 0 ; i < n ; i++ )
		maxr[i] = fgetint();

	for( i = n - 1 ; i-- ; ){
		int a = fgetint() - 1;
		int b = fgetint() - 1;

		adj[a].push_back( b );
		adj[b].push_back( a );
	}

	//aintn = 1;
	//while( aintn < n )
	//	aintn <<= 1;

	//for( i = 2 * aintn - 1 ; i-- ; )
	//	aint[i] = +INF;

	sp = 0;
	dep[0] = -1;
	par[0] = 0;
	pre( 0 );

	for( i = 0 ; i < n ; i++ )
		dp[i] = +INF;

	//for( i = 0 ; i < n ; i++ ){
	for( int u = n ; u-- ; ){
		i = preo[u];

		R = maxr[i];

		for( int j = 0 ; j < n ; j++ )
			distl[j].clear();

		dist[i] = 0;
		getdist( i, i );

		highest = i;
		for( r = 0 ; r < R ; r++ ){
			if( r )
				highest = par[highest];
			int tot = costr[r];

			for( int j : distl[r + 1] ){ // se amortizeaza (vizitam fiecare nod de maxim o data)
				if( j != par[highest] ){
					if( (dp[j] == +INF) || (tot == +INF) )
						tot = +INF;
					else
						tot += dp[j];
				}
			}

			upddp( highest, tot ); // incet, vreau doar sa mearga
		}
	}

	//for( i = 0 ; i < n ; i++ )
	//	printf( "dp[%d] = %d\n", i, dp[i] );

	printf( "%d\n", dp[0] == +INF ? -1 : dp[0] );

	return 0;
}