#include <stdio.h>
#include <ctype.h>

#include <vector>
#include <algorithm>

#define magic_sauce inline __attribute__((always_inline))

magic_sauce int fgetint(){
	int n = 0, ch;

	while( !isdigit( ch = fgetc( stdin ) ) );
	do
		n = n * 10 + ch - '0';
	while( isdigit( ch = fgetc( stdin ) ) );

	return n;
}

const int MAXN = 1e5;

int sd[1 + MAXN];

const int QUERY = 1;
const int UPDATE = 0;
struct Event { int time, type, x, y, idx; };
// V, Query, st, dr, idx
// sdiv, Update, poz, NaN, NaN

int aib[1 + MAXN];

std::vector<Event> evt;

int out[MAXN];

int main(){
	int n, d, i;

	evt.push_back( Event{ 0, UPDATE, 1, 0, 0 } );
	for( d = 2 ; d <= MAXN ; d++ ){
		evt.push_back( Event{ 1 + sd[d], UPDATE, d, 0, 0 } );
		for( i = 2 * d ; i <= MAXN ; i += d )
			sd[i] += d;
	}

	n = fgetint();
	for( i = 0 ; i < n ; i++ ){
		int st, dr, val;

		st = fgetint();
		dr = fgetint();
		val = fgetint();

		evt.push_back( Event{ val, QUERY, st - 1, dr, i } );
	}

	std::sort( evt.begin(), evt.end(), []( const Event &a, const Event &b ) -> bool {
		if( a.time != b.time )
			return a.time < b.time;

		return a.type < b.type;
	} );

	for( Event e : evt ){
		if( e.type == UPDATE ){
			i = e.x;
			while( i <= MAXN ){
				aib[i]++;
				i += (i & -i);
			}
		}else{
			int ans = (e.y - e.x);

			i = e.x;
			while( i ){
				ans += aib[i];
				i &= (i - 1);
			}
			i = e.y;
			while( i ){
				ans -= aib[i];
				i &= (i - 1);
			}

			out[e.idx] = ans;
		}
	}

	for( i = 0 ; i < n ; i++ )
		printf( "%d\n", out[i] );

	return 0;
}