#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
ifstream fin("input.txt");
#define cin fin
#endif

#define lsb(x) (x & (-x))

struct Query {
    int l, r, v, idx;
};

const int NMAX = 1e5+50;
const int AIBMAX = 304930;

int m, n;
Query q[NMAX];
int aib[AIBMAX];
int bsz;
int sum_div[NMAX];
int bucket[NMAX];
int ans[NMAX];
int a[NMAX];

void aib_update(int pos, int val) {
    a[pos] += val;
    for (int i = pos; i >= 1; i -= lsb(i)) {
        aib[i] += val;
    }
}

int aib_query(int pos) {
    if (pos >= AIBMAX)
        return 0;
    int sum = 0;
    for (int i = pos; i < AIBMAX; i += lsb(i))
        sum += aib[i];
    return sum;
}

bool cmp(const Query &a, const Query &b) {
    if (bucket[a.l] == bucket[b.l])
        return a.r < b.r;
    return bucket[a.l] < bucket[b.l];
}

void read() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> q[i].l >> q[i].r >> q[i].v;
        q[i].idx = i;
        n = max(n, q[i].r);
    }
}

void precalc() {
    for (int i = 1; i * i < NMAX; i++) {
        for (int j = i * 2; j < NMAX; j += i) {
            sum_div[j] += i;
        }
    }
    bsz = sqrt(n);
    for (int i = 1; i <= n; i++)
        bucket[i] = ((i - 1) / bsz + 1);
}

void solve() {
    sort(q + 1, q + m + 1, cmp);
    int l = q[1].l, r = q[1].r;
    for (int i = l; i <= r; i++)
        aib_update(sum_div[i], 1);
    ans[q[1].idx] = aib_query(q[1].v + 1);
    for (int i = 2; i <= m; i++) {
        while (l < q[i].l) {
            aib_update(sum_div[l++], -1);
        }
        while (q[i].l < l) {
            aib_update(sum_div[--l], 1);
        }
        while (r < q[i].r) {
            aib_update(sum_div[++r], 1);
        }
        while (q[i].r < r) {
            aib_update(sum_div[r--], -1);
        }
        ans[q[i].idx] = aib_query(q[i].v + 1);
    }

    for (int i = 1; i <= m; i++)
        cout << ans[i] << '\n';
}

int main() {
    read();
    precalc();
    solve();
    return 0;
}
