#include <bits/stdc++.h>
#define int long long
#define X first
#define Y second
#define mp make_pair

using namespace std;
using pii = pair <int, int>;

constexpr int maxn = 2e3 + 10;
constexpr int inf = 1e17 + 10;

int tin [maxn], tout [maxn], timer = 0;
vector <int> graph [maxn];

inline void _dfs (int v, int p = -1) {
    tin[v] = ++timer;
    for (int i : graph[v]) if (i != p) _dfs (i, v);
    tout[v] = timer;
}

int n, c [maxn], t [maxn];
int dp [maxn][maxn];
vector <int> dist [maxn];

int tree [maxn << 2];
bool W [maxn << 2];

inline void push (int v, int t_l, int t_r) {
    if (!W[v]) return;
    W[v] = false;
    if (t_l < t_r) W[v << 1] = W[v << 1 | 1] = true;
    tree[v] = 0;
}

inline void inc (int l, int r, int v, int t_l, int t_r) {
    push (v, t_l, t_r);
    if (t_l > r || l > t_r) return;
    if (l <= t_l && t_r <= r) {
        W[v] = true;
        push (v, t_l, t_r);
        return;
    }
    int t_m = t_l + t_r >> 1;
    inc (l, r, v << 1, t_l, t_m);
    inc (l, r, v << 1 | 1, t_m + 1, t_r);
    tree[v] = tree[v << 1] + tree[v << 1 | 1];
}

inline int get (int l, int r, int v, int t_l, int t_r) {
    if (l > t_r || t_l > r) return 0;
    push (v, t_l, t_r);
    if (l <= t_l && t_r <= r) return tree[v];
    int t_m = t_l + t_r >> 1;
    return get (l, r, v << 1, t_l, t_m) + get (l, r, v << 1 | 1, t_m + 1, t_r);
}

inline void update (int i, int x, int v, int t_l, int t_r) {
    push (v, t_l, t_r);
    if (i > t_r || t_l > i) return;
    if (t_l == t_r) {
        tree[v] = x;
        return;
    }
    int t_m = t_l + t_r >> 1;
    update (i, x, v << 1, t_l, t_m);
    update (i, x, v << 1 | 1, t_m + 1, t_r);
    tree[v] = tree[v << 1] + tree[v << 1 | 1];
}

inline void dfs1 (int v, int p, int D) {
    dist[D].push_back (v);
    for (int i : graph[v]) if (i != p) dfs1 (i, v, D + 1);
}

inline void dfs (int v, int p = -1) {
    inc (0, n + 1, 1, 0, n + 1);
    for (int i : graph[v]) if (i != p) dfs (i, v);
    for (int i = 0; i <= n + 1; ++i) dist[i].clear (), dp[v][i] = inf;
    for (int i : graph[v]) if (i != p) {
        dfs1 (i, v, 1);
    }
    for (int i = 1; i <= t[v]; ++i) {
        inc (0, n + 1, 1, 0, n + 1);
        int result = 0;
        for (int j : dist[i]) update (tin[j], dp[j][1], 1, 0, n + 1), result += dp[j][1];
        for (int j = 1; j < i; ++j) {
            for (int x : dist[i - j]) {
                int S = get (tin[x], tout[x], 1, 0, n + 1);
                if (S <= dp[x][j + 1]) continue;
                result += dp[x][j + 1] - S;
                inc (tin[x] + 1, tout[x], 1, 0, n + 1);
                update (tin[x], dp[x][j + 1], 1, 0, n + 1);
            }
        }
        int delta = 0;
        for (int j : graph[v]) if (j != p) {
            int S = get (tin[j], tout[j], 1, 0, n + 1);
            delta = min (delta, dp[j][i + 1] - S - c[i]);
        }
        dp[v][i] = min (dp[v][i], result + c[i] + delta);
    }
    for (int i = t[v] + 1; i <= n; ++i) {
        inc (0, n + 1, 1, 0, n + 1);
        int result = 0;
        for (int j : dist[i]) update (tin[j], dp[j][1], 1, 0, n + 1), result += dp[j][1];
        for (int j = 1; j < i; ++j) {
            for (int x : dist[i - j]) {
                int S = get (tin[x], tout[x], 1, 0, n + 1);
                if (S <= dp[x][j + 1]) continue;
                result += dp[x][j + 1] - S;
                inc (tin[x] + 1, tout[x], 1, 0, n + 1);
                update (tin[x], dp[x][j + 1], 1, 0, n + 1);
            }
        }
        int delta = inf;
        for (int j : graph[v]) if (j != p) {
            int S = get (tin[j], tout[j], 1, 0, n + 1);
            delta = min (delta, dp[j][i + 1] - S);
        }
        dp[v][i] = min (dp[v][i], result + delta);
    }
    for (int i = n - 1; i > 0; --i) dp[v][i] = min (dp[v][i], dp[v][i + 1]);
}

inline void solve () {
    int u, v;
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> c[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v, --u, --v;
        graph[u].push_back (v);
        graph[v].push_back (u);
    }
    _dfs (0);
    dfs (0);
    cout << (dp[0][1] == inf ? -1LL : dp[0][1]) << '\n';
}

signed main () {
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve ();
    return 0;
}


/*

5
1 111 111 111 111
4 4 4 4 4
1 2
2 3
3 4
4 5


*/
