#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1e5 + 5;
int sum[N] = {};

vector <int> add[N], del[N];

int SumOfDivisors(int n) {
    int nn = n;
    int sum = 1;
    for (int i = 2; i * i <= n; i ++) {
        if (n % i != 0) continue;
        int add = 0;
        int p = 1;
        while (n % i == 0) {
            p *= i;
            add += sum * p;
            n /= i;
        }
        sum += add;
    }
    if (n > 1) {
        sum = sum + sum * n;
    }
    return sum - nn;
}

void Calc() {
    for (int i = 0; i < N; i ++)
        sum[i] = SumOfDivisors(i);
}

struct Query {
    int l, r, v;
    int i;
    int val;
    int res;
};
bool cmp1(Query a, Query b) {
    return a.v < b.v;
}
bool cmp2(Query a, Query b) {
    return a.i < b.i;
}

struct SegmentTree {
    int sz;
    vector <int> tree;
    void Init(int n) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        tree.assign(sz * 2, 0);
    }
    int Get(int v) {
        int res = 0;
        v += sz;
        while (v) {
            res += tree[v];
            v /= 2;
        }
        return res;
    }
    /*void Add(int v) {
        v += sz;
        v /= 1;
        while ()
    }*/
    int Sum(int v, int l, int r, int ql, int qr) {
        if (ql > r || qr < l)
            return 0;
        if (l >= ql && r <= qr)
            return tree[v];
        int m = (l + r) / 2;
        int s1 = Sum(v * 2, l, m, ql, qr);
        int s2 = Sum(v * 2 + 1, m + 1, r, ql, qr);
        return s1 + s2;
    }
    void Change(int v, int val) {
        v += sz;
        tree[v] += val;
        v /= 2;
        while (v) {
            tree[v] = tree[v * 2] + tree[v * 2 + 1];
            v /= 2;
        }
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    Calc();

    int q;
    cin >> q;
    Query qu[q];
    
    for (int i = 0; i < q; i ++) {
        int l, r, v;
        cin >> l >> r >> v;
        qu[i] = {l, r, v, i, 0};
    }
    sort(qu, qu + q, cmp1);
    for (int i = 0; i < q; i ++) {
        //cout << qu[i].v << " -> " << i + 1 << '\n';
        qu[i].val = i + 1;
        add[qu[i].l].push_back(i + 1);
        del[qu[i].r].push_back(i + 1);
    }
    for (int i = 0; i < N; i ++) {
        int l = 0, r = q - 1;
        while (l < r) {
            int mid = l + (r - l + 1) / 2;
            if (qu[mid].v >= sum[i])
                r = mid - 1;
            else
                l = mid;
        }
        if (sum[i] <= qu[0].v) {
            sum[i] = 0;
            continue;
        }
        l ++;
        //cout << sum[i] << ' ' << l << '\n';
        sum[i] = l;
    }
    //
    SegmentTree st;
    st.Init(q + 1);

    for (int i = 0; i < N; i ++) {
        for (auto a : add[i]) {
            qu[a - 1].res = -st.Sum(1, 0, st.sz - 1, a, q);
        }
        //cout << i << " : (" << sum[i] << ") ";
        
        st.Change(sum[i], 1);
        //for (int i = 0; i < st.sz * 2; i ++) cout << st.tree[i] << ' ';
        //cout << '\n';
        for (auto d : del[i]) {
            qu[d - 1].res += st.Sum(1, 0, st.sz - 1, d, q);
        }
    }

    sort(qu, qu + q, cmp2);
    for (int i = 0; i < q; i ++)
        cout << qu[i].res << '\n';//
    return 0;
}