#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 128;

int cnt[MAXN];

void init() {
    cnt[0] = cnt[1] = 0;
    for (int i = 2; i < MAXN; i++) {
        cnt[i]++;
        for (int j = 2 * i; j < MAXN; j += i)
            cnt[j] += i;
    }
}

vector<int> t[4 * MAXN];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v].push_back(cnt[tl]);
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);

    auto& res = t[v];
    int i = 0, j = 0;
    int left_son = t[v << 1].size(), right_son = t[v << 1 | 1].size();
    while (i < left_son || j < right_son) {
        if (i >= left_son)
            res.push_back(t[v << 1 | 1][j++]);
        else if (j >= right_son)
            res.push_back(t[v << 1][i++]);
        else if (t[v << 1][i] < t[v << 1 | 1][j])
            res.push_back(t[v << 1][i++]);
        else
            res.push_back(t[v << 1 | 1][j++]);
    }
}

int get(int l, int r, int val, int v, int tl, int tr) {
    if (tl > r || tr < l)
        return 0;
    if (l <= tl && tr <= r) {
        int i = (int) (upper_bound(t[v].begin(), t[v].end(), val) - t[v].begin());
        return (int) t[v].size() - i;
    }
    int tm = (tl + tr) >> 1;
    return get(l, r, val, v << 1, tl, tm) +
            get(l, r, val, v << 1 | 1, tm + 1, tr);
}

int stupid_calc(int v) {
    int sum = 0;
    for (int i = 1; i * i <= v; i++)
        if (v % i == 0)
            sum += i + v / i;
    if ((int) sqrt(v) * (int) sqrt(v) == v)
        sum -= (int) sqrt(v);
    return sum-v;
}


main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    init();
    build(1, 0, MAXN - 1);

    int t;
    cin >> t;
    while (t--) {
        int l, r, v;
        cin >> l >> r >> v;
        cout << get(l, r, v, 1, 0, MAXN - 1) << '\n';
    }
    return 0;
}

