#include <bits/stdc++.h>

#pragma GCC Optimize("Ofast")

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

template <class T>
using ordered_set = tree <T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 1e5 + 5;

int cnt[MAXN];

void init() {
    cnt[0] = cnt[1] = 0;
    for (int i = 2; i < MAXN; i++) {
        cnt[i]++;
        for (int j = 2 * i; j < MAXN; j += i)
            cnt[j] += i;
    }
}

ordered_set<int> t[4 * MAXN];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v].insert(cnt[tl]);
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);

    for (auto c : t[v << 1])
        t[v].insert(c);
    for (auto c : t[v << 1 | 1])
        t[v].insert(c);
}

int get(int l, int r, int val, int v, int tl, int tr) {
    if (tl > r || tr < l)
        return 0;
    if (l <= tl && tr <= r) {
        return (int) t[v].size() - (int) t[v].order_of_key(val + 1);
//        int i = (int) (upper_bound(t[v].begin(), t[v].end(), val) - t[v].begin());
//        return (int) t[v].size() - i;
    }
    int tm = (tl + tr) >> 1;
    return get(l, r, val, v << 1, tl, tm) +
            get(l, r, val, v << 1 | 1, tm + 1, tr);
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    init();
    build(1, 0, MAXN - 1);

    int t;
    cin >> t;
    while (t--) {
        int l, r, v;
        cin >> l >> r >> v;
        cout << get(l, r, v, 1, 0, MAXN - 1) << '\n';
    }
    return 0;
}

