#include <bits/stdc++.h>

#pragma GCC Optimize("Ofast")
#pragma GCC Optimize("unroll-loops")

#define watch(x) cout << (#x) << " : " << x << '\n'

using namespace std;

const int MAXN = 1e5 + 5;

vector <int> cnt(MAXN, 0);

void init() {
    cnt[0] = cnt[1] = 0;
    for (int i = 2; i < MAXN; i++) {
        cnt[i]++;
        for (int j = 2 * i; j < MAXN; j += i)
            cnt[j] += i;
    }
}

vector < int > q[MAXN];

unordered_map <int, int> res[MAXN];

vector < vector<int> > saved;

int t[4 * MAXN];

struct tree {
    void add(int pos, int v, int tl, int tr) {
        if (tl > pos || tr < pos)
            return;
        if (tl == tr && pos == tl) {
            t[v]++; return;
        }
        int tm = (tl + tr) >> 1;
        add(pos, v << 1, tl, tm);
        add(pos, v << 1 | 1, tm + 1, tr);
        t[v] = t[v << 1] + t[v << 1 | 1];
    }

    int get(int l, int r, int v, int tl, int tr) {
        if (tl > r || tr < l)
            return 0;
        if (l <= tl && tr <= r)
            return t[v];
        int tm = (tl + tr) >> 1;
        return get(l, r, v << 1, tl, tm) + get(l, r, v << 1 | 1, tm + 1, tr);
    }

    void add(int pos) {
        add(pos, 1, 0, MAXN - 1);
    }

    int get(int l, int r) {
        return get(l, r, 1, 0, MAXN - 1);
    }
};

int main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0); cout.tie(0);

    init();

    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        int l, r, v;
        cin >> l >> r >> v;
        saved.push_back({l, r, v});
        if (l) q[l-1].push_back(v);
        q[r].push_back(v);
    }

    tree T;
    vector <int> st = cnt;
    sort(st.begin(), st.end());

    auto get_count = [&](int val) -> int {
        if (st.front() > val)
            return cnt.size();
        if (st.back() <= val)
            return 0;

        int l = 0, r = st.size() - 1;
        while (l + 1 < r) {
            int m = (l + r) >> 1;
            if (st[m] <= val)
                l = m;
            else
                r = m;
        }

        int ans = l;
        while (ans < MAXN && st[ans] <= val) ans++;
        int tot = st.size() - ans - T.get(st[ans], MAXN-1);

        return tot;
    };

    while (!cnt.empty()) {
        int pos = cnt.size() - 1;

        for (auto v : q[pos]) {
            res[pos][v] = get_count(v);
        }

        T.add(cnt.back());
        cnt.pop_back();
    }

    for (auto c : saved) {
        int l = c[0], r = c[1], v = c[2];

        cout << res[r][v] - res[l-1][v] << '\n';
    }

    return 0;
}

