//
//  coins.cpp
//  25.11 IATI 1st day
//
//  Created by Kseniia on 25.11.2022.
//

#include "coins.h"

#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <cstring>
#include <unordered_map>

#define endl '\n'

using namespace std;
typedef int ll;

ll ask(ll l, ll r){
    ll mid = (l + r) >> 1;
    
    vector<ll>a, b;
    
    for(int i = l; i <= mid; i++)
        a.push_back(i);
    for(int i = mid + 1; i <= r; i++)
        b.push_back(i);
    
    return weigh(a, b);
}

pair<int, int> count_heavy(int k){
    
    int l = 0, r = (1 << k) - 1;
    
    ll amount = (k == 1 ? 1 : 0);
    
    while(l < r){
        ll cnt = ask(l, r);
        ll mid = (l + r) >> 1;
        
        if(cnt == -1){
            if(l + 1 == r){
                l = r;
                break;
            }
            
            ll l2 = mid + 1, r2 = r;
            
            if(ask(l2, r2) == 0){
                amount = (1 << k) - 1;
                r = mid;
            }
            else{
                amount = 1;
                l = mid + 1;
            }
        }
        else if(cnt == 1){
            if(l + 1 == r){
                r = l;
                break;
            }
            
            ll l2 = l, r2 = mid;
            
            if(ask(l2, r2) == 0){
                amount = (1 << k) - 1;
                l = mid + 1;
            }
            else{
                amount = 1;
                r = mid;
            }
        }
    }
    
    return {amount, l};
}
