#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include "coins.h"

using namespace std;

map<pair<int, int>, int> res;

int w(int a, int b) {
    int g = 1;
    if (a > b) {
        swap(a, b);
        g = -1;
    }
    if (res.find({a, b}) != res.end()) {
        return res[{a, b}] * g;
    }
    if (a == b) {
        return true;
    }
    return weigh({a}, {b}) * g;
}


bool cmp(int a, int b) {
    if (a == b)
        return true;
    int val = w(a, b);
    if (val >= 0) {
        return true;
    } else
        return false;
}


pair<int, int> count_heavy(int K) {
    vector<int> coins;

    for (int i = 0; i < (1 << K); i++)
        coins.push_back(i);

    sort(coins.begin(), coins.end(), cmp);

    int f = coins[0];
    int l = 0;
    int r = coins.size() - 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int val = w(f, coins[m]);
        if (val <= 0) {
            l = m;
        } else
            r = m;
    }
    if (w(coins[l], coins[r]) <= 0) {
        return {r + 1, f};
    } else
        return {r, f};
}
