#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include "coins.h"

using namespace std;
int KK = 0;
map<pair<int, int>, int> res;

int w(int a, int b) {
    if (a >= (1 << KK) || a < 0)
        return false;
    if (b >= (1 << KK) || b < 0)
        return true;
    int g = 1;
    if (a > b) {
        swap(a, b);
        g = -1;
    }
    if (res.find({a, b}) != res.end()) {
        return res[{a, b}] * g;
    }
    if (a == b) {
        return true;
    }
    return weigh({a}, {b}) * g;
}

bool cmp(int a, int b) {
    if (a == b)
        return true;
    int val = w(a, b);
    if (val >= 0) {
        return true;
    } else
        return false;
}


void merge(vector<int>& l, vector<int>& r, vector<int>& res) {
    res.clear();
    int pl = 0;
    int pr = 0;
    while (pl != l.size() and pr != r.size()) {
        if (cmp(l[pl], r[pr])) {
            res.push_back(l[pl]);
            pl++;
            continue;
        } else {
            res.push_back(r[pr]);
            pr++;
        }
    }
    while (pl != l.size())
        res.push_back(l[pl]), pl++;


    while (pr != r.size())
        res.push_back(r[pr]), pr++;

}

void merge_sort(vector<int> &v) {
    if (v.size() == 1)
        return;
    int half = v.size() / 2;
    vector<int> l;
    vector<int> r;
    for (int i = 0; i < v.size(); i++) {
        if (i >= half)
            r.push_back(v[i]);
        else
            l.push_back(v[i]);;
    }

    merge_sort(l);
    merge_sort(r);
    v.clear();
    merge(l, r, v);
}


pair<int, int> count_heavy(int K) {

    KK = K;
    vector<int> coins;

    for (int i = 0; i < (1 << K); i++)
        coins.push_back(i);

    merge_sort(coins);

    int f = coins[0];
    int l = 0;
    int r = coins.size() - 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int val = w(f, coins[m]);
        if (val <= 0) {
            l = m;
        } else
            r = m;
    }

    if (r == coins.size() - 1)
        return {r, f};
    if (w(coins[l], coins[r]) <= 0) {
        return {r + 1, f};
    } else
        return {r, f};
}
