#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>

using namespace std;

#define int long long
#define maxN 100005
#define endl "\n"


vector<int> gtt(maxN + 5, 0);

int bareSum(int x) {

    int sum = 0;
    for (int i = 1; i * i <= x; i++) {
        if (i * i == x) {
            sum += i;
            break;
        }
        if (x % i == 0) {
            sum += i + x / i;
        }
    }
    return sum;
}

int sum(int x) {
    if (x == 1) {
        gtt[1] = 1;
        return 0;
    }
    int ans = 0;
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            int h = i;
            while (x % h == 0) {
                h *= i;
            }
            h /= i;
            if (h == x) {
                gtt[x] = bareSum(x);
                return gtt[x] - x;
            }
            int g = x / h;
            ans = (gtt[h]) * (gtt[g]);
            break;
        }

    }
    if (ans == 0)
        ans = x + 1;
    gtt[x] = ans;
    return ans - x;
}


struct Vertex {
    Vertex *left;
    Vertex *right;
    int val;

    Vertex(int s = 0) : left(nullptr), right(nullptr), val(s) {
    }

    Vertex(Vertex *l, Vertex *r) : left(l), right(r), val(l->val + r->val) {

    }

};

class Tree {
public:
    vector<Vertex *> versions;
    vector<int> a;

    Vertex *build(int l, int r) {
        if (l == r)
            return new Vertex(a[l]);

        int mid = (l + r) / 2;
        auto left = build(l, mid);
        auto right = build(mid + 1, r);
        return new Vertex(left, right);
    }

    int get(Vertex *cur, int tl, int tr, int l, int r) {
        if (l > r)
            return 0;
        if (tl == l and r == tr)
            return cur->val;
        int mid = (tl + tr) / 2;
        return get(cur->left, tl, mid, l, min(r, mid)) + get(cur->right, mid + 1, tr, max(l, mid + 1), r);
    }


    Vertex *update(Vertex *v, int tl, int tr, int pos, int newVal) {
        if (tl == tr) {
            return new Vertex(v->val + newVal);
        } else {
            int tm = (tl + tr) / 2;
            Vertex *l;
            Vertex *r;
            if (pos <= tm)
                l = update(v->left, tl, tm, pos, newVal), r = v->right;
            else
                r = update(v->right, tm + 1, tr, pos, newVal), l = v->left;
            return new Vertex(l, r);
        }
    }

    Tree(vector<int> &a) {
        this->a = a;
        versions.push_back(build(0, a.size() - 1));
    }

    int get(int l, int r, int v) {
        return get(versions[v], 0, a.size() - 1, l, r);
    }

    void update(int pos, int newVal, bool save = true) {
        if (!save)
            versions.back() = update(versions.back(), 0, a.size() - 1, pos, newVal);
        else
            versions.push_back(update(versions.back(), 0, a.size() - 1, pos, newVal));
    }
};


signed main() {


    vector<int> z(maxN, 0);
    Tree t(z);
    for (int i = 0; i < maxN; i++) {
        t.update(0, 1);
        t.update(sum(i + 1), -1, false);
    }
    cout << 1  / 0<< endl;
    int q = 0;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int a, b, c;
        scanf("%lld%lld%lld", &a, &b, &c);
        int r = t.get(0, c, b);
        int l = t.get(0, c, a - 1);
        cout << r - l << endl;
    }
}
//0 1 1 3 1 6 1 7 4 8 1   16 1 10 9 15 1 21 1 22    11 14 1 36 6 16 13 28 1 42 6